// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
// 'starter.controllers' is found in controllers.js

var postLensApp = angular.module('postLensApplication', ['ionic', 'postLensApplication.controllers', 'ngI18n', 'ionic.rating', 'uiGmapgoogle-maps', 'ti-segmented-control', 'ab-base64','ngIOS9UIWebViewPatch'])

.run(function($ionicPlatform) {

  $ionicPlatform.ready(function() {
    // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
    // for form inputs)
    if (window.cordova && window.cordova.plugins.Keyboard) {
      cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
    }
    if (window.StatusBar) {
      // org.apache.cordova.statusbar required
      StatusBar.styleDefault();
    }
    if (!window.cordova) {
    	navigator.notification = {
    		confirm: function(msg, cb) {
    			var val = window.confirm(msg);
    			cb(val ? 1 : 0);
    		},
    		alert: function(msg) {
    			window.alert(msg);
    		}
    	}
    }

    console.log('device is now ready');

  });
})
// Internationalization module for AngularJS
.value('ngI18nConfig', {
	// defaultLocale should be in lowercase and is required!!
	defaultLocale : 'en',
	// supportedLocales is required - all locales should be in lowercase!!
	supportedLocales : [ 'en', 'th' ],
	// without leading and trailing slashes, default is i18n
	basePath : 'i18n',
	// default is false
	cache : true
})
.value('appInfo', function($ionicPlatform){
	return {
		appVersion: '1.1',
		platform: $ionicPlatform.platform,
		osVersion: $ionicPlatform.version
	}
})
// .value('apiBaseUrl', 'http://127.0.0.1:6442/api')
// .value('apiBaseUrl', 'http://192.168.19.169:6442/api')
.value('apiBaseUrl', 'http://mobile.thailandpost.com:3000/api/v2')
// .value('apiBaseUrl', 'http://localhost:3000/api/v2')
// .value('apiBaseUrl', 'http://192.168.43.250:3000/api')
.config(function(uiGmapGoogleMapApiProvider) {
    uiGmapGoogleMapApiProvider.configure({
        key: 'AIzaSyA8LyhRZyMnjoZ0OduQFQdnjZ5mMqUJ6OI',
        v: '3.27',
        libraries: 'weather,geometry,visualization'
    });
})
.constant('isPhone', function(){
//return true;
	var mquery = window.matchMedia("only screen and (min-width: 600px) and (min-height: 600px)");
	console.log(mquery);
	return !mquery.matches;
//   console.log(window.matchMedia("only screen and (max-width: 640px) and (max-height: 640px)"));
//   if(window.matchMedia("only screen and (max-width: 640px)").matches)
//   return true;
//   return false;
})
.directive('thEnText', function(){ //default = th
	return function(scope, elm, attrs) {
		var thflag = scope.checkThaiLanguage; // !!attrs.th && scope[attrs.th] == true
		var enflag = scope.checkEnglishLanguage; // !!attrs.en && scope[attrs.en] == true
		updateFlag();
		if (attrs.thEnText == "nolive") {
			//do nothing (0 watchers)
		} else if (attrs.thEnText == "watch2") {
			//watch only first language (1 watcher)
			if (thflag) scope.$watch(attrs.thText, function(nv){updateFlag();1;});
			if (enflag) scope.$watch(attrs.enText, function(nv){updateFlag();2;});
		} else {
			//watch value and language (2 watchers)
			var w;
			var checktl = scope.$watch('checkThaiLanguage', function(nv){
				thflag = nv;
				if (nv) {w&&w(); w = scope.$watch(attrs.thText, function(nv){updateFlag();3;});}
				updateFlag();
			});
			var checkel = scope.$watch('checkEnglishLanguage', function(nv){
				enflag = nv;
				if (nv) {w&&w(); w = scope.$watch(attrs.enText, function(nv){updateFlag();4;});}
 				updateFlag();
			});
			scope.$on('$destroy', function(){
				//console.info('destroy thEnText', !!checktl, !!checkel, !!w);
				checktl&&checktl();
				checkel&&checkel();
				w&&w();
			})
		}
		function updateFlag() {
			var result = 'N/A';
			var thText = (scope.$eval(attrs.thText)||'').trim() || '.';
			if (!!attrs.thText && thflag) {
				result = thText;
			} else if (!!attrs.enText && enflag) {
				result = (scope.$eval(attrs.enText)||'').trim() || thText;
			}
			elm.text(result);
			scope.$applyAsync();
			//if (!scope.$$phase) scope.$apply();
		}
	}
})
.directive('googlemapDirection', function () {
	return function(scope, el, attr) {
		var showDirection = scope.$on('showDirection'
				, function(event, directionRenderer) {
			console.log("do showDirection...");
			console.info(el);
			directionRenderer.setPanel(el[0]);
		});

		// always cleanup
		scope.$on('$destroy', function(event) {
			showDirection();
		});

	}
} )
.directive("compareTo", function() {
    return {
        require: "ngModel",
        scope: {
            otherModelValue: "=compareTo"
        },
        link: function(scope, element, attributes, ngModel) {

            ngModel.$validators.compareTo = function(modelValue) {
                return modelValue == scope.otherModelValue;
            };

            scope.$watch("otherModelValue", function() {
                ngModel.$validate();
            });
        }
    };
})


.config(function($stateProvider, $urlRouterProvider, isPhone,$ionicConfigProvider) {

	$ionicConfigProvider.tabs.position('bottom');
	$ionicConfigProvider.backButton.icon('my-back-button');//icon
	$ionicConfigProvider.backButton.text('').previousTitleText(false);//ลบtext
	var templateFolder = isPhone() ? 'phone_templates/' : 'templates/';

  $stateProvider

  .state('app', {
    url: "/app",
    abstract: true,
    templateUrl: "templates/menu.html",
    controller: 'AppCtrl'
  })
  .state('app.searchshop', {
	url: "/searchshop",
    views: {
        'menuContent': {
            templateUrl : 'templates/searchshop.html',
            controller : 'searchCtrl'
        }
    }
	})
 //  .state('app.bookmark', {
	// url: "/bookmark",
 //    views: {
 //        'menuContent': {
 //            templateUrl:'templates/bookmark.html',
 //            controller:'bookmarkCtrl'
 //        }
 //    }
	// })
	.state('app.recommended', {
		url: "/recommended",
		views: {
			'menuContent': {
				templateUrl:'templates/recommended.html',
				controller:'recommendedCtrl'
			}
		}
	})
	.state('app.login_form', {
		url: "/login_form",
		views: {
			'menuContent': {
				templateUrl:'templates/login.html',
				controller:'loginCtrl'
			}
		}
	})
	.state('app.register', {
		url: "/register",
		views: {
			'menuContent': {
				templateUrl:'templates/register.html',
				controller:'registerCtrl'
			}
		}
	})
	.state('app.following', {
		url: "/following",
		views: {
			'menuContent': {
				templateUrl : 'templates/following_list.html',
				controller : 'followingCtrl'
			}
		}
	})
	.state('app.follow', {
		url: "/follow",
		views: {
			'menuContent': {
				templateUrl : 'templates/follow_list.html',
				controller : 'followCtrl'
			}
		}
	})

	.state('app.branch', {
		url: "/branch/:id",
		cache: false,
		abstract: true,
		views: {
			'menuContent' : {
				templateUrl: "templates/branch_tabs.html",
				controller: function($scope, $stateParams, shopInfoService,$rootScope) {
					/*$scope._tab_promo = '<img class="icon" src="images/icons/promotion.png"><span class="tab-title">Promo</span>';
					$scope._tab_coupon = '<img class="icon" src="images/icons/coupons.png"><span class="tab-title">Coupon</span>';
					$scope._tab_comment = '<img class="icon" src="images/icons/comment.png"><span class="tab-title">Comment</span>';
					$scope._tab_photo = '<img class="icon" src="images/icons/gallery.png"><span class="tab-title">Photo</span>';
					$scope._tab_map = '<img class="icon" src="images/icons/maps.png"><span class="tab-title">Map</span>';*/
          $scope._tab_promo = '<span class="tab-title">Promo</span>';
					$scope._tab_coupon = '<span class="tab-title">Coupon</span>';
					$scope._tab_comment = '<span class="tab-title">Comment</span>';
					$scope._tab_photo = '<span class="tab-title">Photo</span>';
					$scope._tab_map = '<span class="tab-title">Map</span>';

					//ionic bug: this state is cached, then $stateParams is the same forever
					//this controller never know the changes, but children know.
					$scope.updateShop = function(shopId) {
					}
          $scope.$on('$ionicView.beforeEnter',function(){
            $rootScope.$broadcast('stop');
          })
          $scope.$on('$ionicView.enter', function() {
      					$rootScope.$broadcast('updateNavBar',{showFB:true,searchshop:false,map_all:false,showAR:false});
          })
					console.info('init', $stateParams.id, $scope.$id);

					$scope.id = $stateParams.id;
					shopInfoService.getShopBranchInfo({shopId: $stateParams.id}
						,function(r){
							if(r.error || !r.result){
								console.error("cannot find shop id", $stateParams.id)
							}else if(r.result){
								$scope.shopInfo = r.result.shopInfo;
								$scope.$broadcast('shopReady', true);
								$scope.$applyAsync();
							}
						});

				}
			}
		}

	})
	.state('app.branch.home', {
		url: "/home",
		views: {
			'home-tab': {
				templateUrl : 'templates/branch.html',
				controller : 'branchCtrl'
			}
		}
	})
	.state('app.branch.map', {
		url: "/map",
		views: {
			'map-tab': {
				templateUrl : templateFolder+'amap.html',
				controller : 'amapCtrl'
			}
		}
	})
	.state('app.branch.branch_service', {
		url: "/branch_service/:serviceCode",
		views: {
			'home-tab': {
				templateUrl : 'templates/branch_service.html',
				controller : 'branchServiceCtrl'
			}
		}
	})
	.state('app.branch.coupon', {
		url: "/coupon",
		views: {
			'coupon-tab': {
				templateUrl : 'templates/coupon.html',
				controller : 'couponCtrl'
			}
		}
	})
	.state('app.branch.promotion', {
		url: "/promotion",
		views: {
			'promo-tab': {
				templateUrl : 'templates/promotion.html',
				controller : 'promotionCtrl'
			}
		}
	})
	.state('app.branch.comment', {
		url: "/comment",
		views: {
			'comment-tab': {
				templateUrl : 'templates/comment.html',
				controller : 'commentCtrl'
			}
		}
	})
	.state('app.branch.imageGallery_shop', {
		url: "/imageGallery_shop",
		views: {
			'photo-tab': {
				templateUrl : 'templates/image_gallery_shop.html',
				controller : 'imageGalleryshopCtrl'
			}
		}
	})
	.state('app.shop', {
		url: "/shop",
		views: {
			'menuContent': {
				templateUrl : 'templates/shop.html',
				controller : 'shopCtrl'
			}
		}
	})
	.state('app.all_coupon', {
		url: "/all_coupon",
		views: {
			'menuContent': {
				templateUrl : 'templates/all_coupon.html',
				controller : 'couponCtrl'
			}
		}
	})
	.state('app.all_promotion', {
		url: "/all_promotion",
		views: {
			'menuContent': {
				templateUrl : 'templates/all_promotion.html',
				controller : 'promotionCtrl'
			}
		}
	})
	.state('app.map', {
		url: "/map",
		views: {
			'menuContent': {
				templateUrl : 'templates/map.html',
				controller : 'MapCtrl'
			}
		}
	})
	.state('app.ar', {
		url: "/ar",
		views: {
			'menuContent': {
				templateUrl : 'templates/ar.html',
				controller : 'ARCtrl'
			}
		}
	})
	.state('app.imageShow', {
		url: "/imageShow",
		views: {
			'menuContent': {
				templateUrl : 'templates/image_show.html',
				controller : 'imageShowCtrl'
			}
		}
	})
	.state('app.imageGallery', {
		url: "/imageGallery",
		views: {
			'menuContent': {
				templateUrl : 'templates/image_gallery.html',
				controller : 'imageGalleryCtrl'
			}
		}
	})
	.state('app.map_all', {
		url: "/map_all",
		views: {
			'menuContent': {
				templateUrl : 'templates/searchshop.html',
				controller : 'searchCtrl'
			}
		}
	})
	.state('app.profile', {
		url: "/profile",
		data: {
			"restricted" : "true"
		},
		views: {
			'menuContent': {
				templateUrl : 'templates/profile.html',
				controller : 'profileCtrl'
			}
		}
	})
	.state('app.change_password', {
		url: "/change_password",
		views: {
			'menuContent': {
				templateUrl : 'templates/change_password.html',
				controller : 'changePasswordCtrl'
			}
		}
	})
	.state('app.user_comment', {
		url: "/user_comment",
		views: {
			'menuContent': {
				templateUrl : 'templates/user_comment.html',
				controller : 'userCommentCtrl'
			}
		}
	})
	.state('app.user_image', {
		url: "/user_image",
		views: {
			'menuContent': {
				templateUrl : 'templates/user_image.html',
				controller : 'userImageCtrl'
			}
		}
	})
	.state('app.adminpost', {
		url: "/adminpost",
		views: {
			'menuContent': {
				templateUrl : 'templates/admin_post.html',
				controller : 'adminPostCrtl'
			}
		}
	})
	.state('app.track', {
		url: "/track",
		views: {
			'menuContent': {
				templateUrl : 'templates/track.html',
				controller : 'trackTraceCtrl'
			}
		}
	})
  .state('app.rating', {
    url: "/rating",
    views: {
      'menuContent': {
        templateUrl : 'templates/rating.html',
        controller : 'ratingCrtl'
      }
    }
  })


  // if none of the above states are matched, use this as the fallback
  $urlRouterProvider.otherwise('/app/searchshop');
});
