angular.module('postLensApplication.controllers', [])
.service('$navigate', function($location){
	var $navigate = {};
	$navigate.go = function(url, animation) {
		console.log(url);
		// $location.path('/app'+url);
    location.hash = '#/app'+url;
	}
	return $navigate;
})
.controller('AppCtrl', function($scope, $ionicModal, $timeout, ngI18nResourceBundle, $navigate, $ionicLoading, $ionicPlatform, 
	provinceService, shopInfoService, wikiARService, $ionicHistory, pushMessageService, $rootScope, userSessionService, facebook) {

  // With the new view caching in Ionic, Controllers are only called
  // when they are recreated or on app start, instead of every page change.
  // To listen for when this page is active (for example, to refresh data),
  // listen for the $ionicView.enter event:
  //$scope.$on('$ionicView.enter', function(e) {
  //});
// nav bar view state

  // // Form data for the login modal
  // $scope.loginForm = {};

  // // Create the login modal that we will use later
  // $ionicModal.fromTemplateUrl('templates/login.html', {
  //   scope: $scope
  // }).then(function(modal) {
  //   $scope.modal = modal;
  // });

  // // Triggered in the login modal to close it
  // $scope.closeLogin = function() {
  //   $scope.modal.hide();
  // };

  // // Open the login modal
  // $scope.login = function() {
  //   $scope.modal.show();
  // };

  // // Perform the login action when the user submits the login form
  // $scope.doLogin = function() {
  //   console.log('Doing login', $scope.loginForm);

  //   // Simulate a login delay. Remove this and replace with your login
  //   // code if using a login system
  //   $timeout(function() {
  //     $scope.closeLogin();
  //   }, 1000);
  // };

  // dev-only //
  if (window.localStorage.userId && !userSessionService.isLogin()) {
  	userSessionService.setUserSession(window.localStorage.user,
  		window.localStorage.userId,
  		window.localStorage.isUserFacebook,
  		window.localStorage.notifyLikeComment,
  		window.localStorage.notifyFollow,
  		window.localStorage.userRef,
  		window.localStorage.isPostLensAdmin)
  	console.log('auto-login')
  }

  //ionic way to do this, instead of manually add the 'backbutton' listener
	var exitApp = false;
	$ionicPlatform.registerBackButtonAction(function () {
		if (exitApp) {
			(navigator.app && navigator.app.exitApp()) || (device && device.exitApp())
		} else {
			if ((window.plugins||'').toast) {
				var text = 'Press back again to exit.';
				if ($scope.checkEnglishLanguage) text = 'Press back again to exit.';
				else text = 'กดอีกครั้งเพื่อออกจากแอพ';
				window.plugins.toast.showShortBottom(text);
			}
			exitApp = true;
			setTimeout(function(){ exitApp = false }, 1500);
		}
	}, 100);

  //////////////////////////
	pushMessageService.initRegisterPushMessage(function(push){
		push.on('notification', function(data) {
			console.log('notification received', data);
			$rootScope.$broadcast('notification', data);
			// data.message,
			// data.title,
			// data.count,
			// data.sound,
			// data.image,
			// data.additionalData
		});

		push.on('error', function(e) {
			//alert('error from push');
			console.log('push error'+e.message);
			// e.message
		});
	})

  //////////////////////////
	try {
		$rootScope.hasAR = false;
		wikiARService.initialize();
	} catch (e) {
		console.log(e.message);
	} finally {

	}
	$scope.$on('wikitudeOK', function(e) {
		console.log('wikitude ok');
		$rootScope.hasAR = true;
		$scope.$broadcast('updateNavBar', {showAR: true});
	})

	$scope.$navigate = $navigate;

	// Language Controller
	$scope.languages = [ {
		locale : "en"
	}, {
		locale : "th"
	} ];

	$scope.i18n = {
		language : $scope.languages[1]
	};
	$scope.checkThaiLanguage = true;
	$scope.checkEnglishLanguage = false;

	$scope.$watch('i18n.language', function(language) {
		console.log(language);
		ngI18nResourceBundle.get({
			locale : language.locale
		}).success(function(resourceBundle) {
			$scope.msg = resourceBundle;
		});
	});

	$scope.toggleLanguageTH = function() {
		console.log('zz');
		$scope.i18n = {
			language : $scope.languages[1]
		};

		$scope.checkThaiLanguage = true;
		$scope.checkEnglishLanguage = false;
		$scope.$broadcast('language-switch', 'th');
	//        $scope.reloadMaps('th');
	}
	$scope.toggleLanguageEN = function(){
		$scope.i18n = {
			language : $scope.languages[0]
		};
		$scope.checkThaiLanguage = false;
		$scope.checkEnglishLanguage = true;
		$scope.$broadcast('language-switch', 'en');
	//        $scope.reloadMaps('en');
	}

	$scope.setLoading = function(flag) {
		if (flag === true) $ionicLoading.show();
		else if (flag == false) $ionicLoading.hide();
	}

	$scope.showAR = function() {
		wikiARService.loadARchitectWorld();
	}

	$scope.$on('updateNavBar',function(event,data){
		//alert(JSON.stringify(data));
		for(var p in data)
		$scope.navbarState[p]=data[p];
		console.log(data);
	});
	var stop=false;
	$scope.$on('stop',function(){
	   stop = true;
	});
	$scope.$on('$ionicView.beforeEnter', function() {
		var arBar = $rootScope.hasAR;
		    if(!stop)
				$scope.navbarState={searchshop:true,map_all:true,showAR:arBar,showFB:false};
				stop = false;
				//$rootScope.$broadcast('updateNavBar',{showFB:true,searchshop:false,map_all:false,showAR:false});
	})

    $scope.shareFacebook = function() {
        console.log('broadcast share fb');
        $scope.$broadcast('sharefb');
    }

    $scope.$on('$stateChangeStart',
        function(event, toState, toParams, fromState, fromParams){
        console.log(toState, toParams, fromState, fromParams);
        if (toState.name.indexOf('app.branch') >= 0) {
            $scope.specialRight = true;

        } else {
            $scope.specialRight = false;
        }
    });

    $scope.isLogin = function(){
      // return true;
      return !!userSessionService.userId;
      // return userSessionService.isLogin();

    }

    $scope.isAdmin = function(){
    	// return true;
      // return !!userSessionService.userId;
    	return userSessionService.isPostLensAdmin == 'Y';
    }



    $rootScope.confirmLogin = function(isNaviageBack){
		//alert($scope.msg.btn_cancel)
    	//navigator.notification.confirm('Please Login First111'
				//+ '\n' + 'Do you want to login now?'
		  navigator.notification.confirm($scope.msg.popup_login
			, function(index) {
				if(index == 1){
					//$scope.login();
					$ionicHistory.clearCache()
					$ionicHistory.nextViewOptions({
						historyRoot: true,
						disableBack: true
					});
					$navigate.go('/login_form');
				}else{
					if(isNaviageBack){
						if ($ionicHistory.backView()) {
							$ionicHistory.goBack();
						} else {
							$ionicHistory.nextViewOptions({
								historyRoot: true,
								disableBack: true
							});
							$navigate.go('/');
						}
					}
				}
			}
			,$scope.msg.popup_text_message //'Message'
			,$scope.msg.btn_ok+','+$scope.msg.btn_cancel);
			/*
			,'Message'
			, 'Yes'+','+'No');*/
    }

    $rootScope.confirmLogout = function(){
    	if(userSessionService.isLogin()){
    		navigator.notification.confirm($scope.msg.popup_logout, function(index) {
    			if (index == 1) {

    				if(userSessionService.isUserFacebook){
    					//logout facebook
                        facebook.logout();
    				}
    				//logout
    				userSessionService.clearUserSession();

                    $ionicHistory.nextViewOptions({
					  historyRoot: true,
					  disableBack: true
					});
					$navigate.go('/');
    			}
    		}, $scope.msg.popup_text_logout, $scope.msg.btn_ok+','+$scope.msg.btn_cancel);
    	}else{
    		alert("not Login!");
    	}

    }

    $scope.toggle = {checkComment:false,checkFollow:false};

    $scope.toggleLanguage = function(index) {
        if (index == 0) $scope.toggleLanguageEN();
        else if (index == 1) $scope.toggleLanguageTH();
        $scope.$applyAsync();
    }

    $scope.toggleComment = function(value) {
    	var flag = value ? 'Y' : 'N';
        if(userSessionService.isLogin()){
            userSessionService.updateLikeCommentConfig(
                {notifyLikeComment: flag, userId: userSessionService.userId},
                function(r){
                    if(r.error || !r.result) console.log('Error:'+ r.error);
                    else{
                        userSessionService.setToggleComment(flag);
                    }
                }
            )
        }else{
            $scope.confirmLogin();
            $scope.toggle.checkComment=false;
        }
    }

    $scope.toggleFollow = function(value) {
    	var flag = value ? 'Y' : 'N';
        if(userSessionService.isLogin()){
            userSessionService.updateFollowConfig(
                {notifyFollow: flag, userId: userSessionService.userId},
                function(r){
                    if(r.error || !r.result) console.log('Error:'+ r.error);
                    else{
                        userSessionService.setToggleFollow(flag);
                    }
                }
            )
        }else{
            $scope.confirmLogin();
            $scope.toggle.checkFollow=false;

        }

    }

    function launchAppSuccess(){
        //alert('launchAppSuccess');
    }

    function launchAppFailure(){
        //alert('launchAppFailure');
    }
    function launchAppFailureTryAppStore(){
        try{
            if($scope.launchApplicationName=='postemart'){
                if(navigator.userAgent.toLowerCase().match(/android/)){
//                    window.startapp.start(
//                        {android: 'th.co.thailandpost.android/th.co.thailandpost.android.ThailandPostQRShopAndroidActivity'},
//                        launchAppSuccess, launchAppFailure
//                    );
                	navigator.startApp.market('th.co.thailandpost.android', launchAppSuccess, launchAppFailure);
                } else if (navigator.userAgent.toLowerCase().match(/iphone/)) {
                    window.startapp.start(
                        {ios: 'itms-apps://itunes.apple.com/th/app/post-e-mart/id590573218?mt=8&uo=4'},
                        launchAppSuccess, launchAppFailure
                    );
                } else if (navigator.userAgent.toLowerCase().match(/ipad/)){
                    window.startapp.start(
                        {ios: 'itms-apps://itunes.apple.com/th/app/post-e-mart/id590573218?mt=8&uo=4'},
                        launchAppSuccess, launchAppFailure
                    );
                }
            }else{
                console.log('No application name on AppStore!');
            }
        }catch(err){console.log('Launch AppAtore search application error:'+err);}
    }

	/*
	$scope.launching = function(applicationName){
		$scope.launchApplicationName = applicationName;
		console.log('launching '+applicationName);
		try{
			if($scope.launchApplicationName=='postemart'){
				if(navigator.userAgent.toLowerCase().match(/android/)){
//                    window.startapp.start(
//                        {android: 'th.co.thailandpost.android/th.co.thailandpost.android.ThailandPostQRShopAndroidActivity'},
//                        launchAppSuccess, launchAppFailureTryAppStore
//                    );
					navigator.startApp.start([['th.co.thailandpost.android','th.co.thailandpost.android.ThailandPostQRShopAndroidActivity']], launchAppSuccess, launchAppFailureTryAppStore);
				} else if (navigator.userAgent.toLowerCase().match(/iphone/)) {
					navigator.startapp.start(
						{ios: 'fb523902184300525://'},//PostEmart version <=1.5
//                        {ios: 'PostEMart://'},////PostEmart version 1.6 up
						launchAppSuccess, launchAppFailureTryAppStore
					);
				} else if (navigator.userAgent.toLowerCase().match(/ipad/)){
					navigator.startapp.start(
						{ios: 'fb523902184300525://'},
//                        {ios: 'PostEMart://'},
						launchAppSuccess, launchAppFailureTryAppStore
					);
				}
			}else{
				console.log('No application name!');
			}
		}catch(err){console.log('Launch another application error:'+err);}
	}
	*/
	var deviceType = ionic.Platform.platform();
	$scope.launching = function(){
		var urlschemeUse = "th.co.thailandpost.postportal://";
		var urlscheme = "th.co.thailandpost.postportal";
		var store = "itms-apps://itunes.apple.com/th/app/post-portal-rabb-hna-cx-hlak/id952956000?mt=8";

		if (deviceType == "ios"){
			urlscheme = "th.co.thailandpost.postportal://";
		}

		appAvailability.check(
			urlscheme, // URI Scheme
			function() {// open app
				window.open(urlschemeUse, '_system');
			},
			function() {// open link app store & play store
				window.open(store, '_system');
			}
		);

	}

});
