'use strict';
postLensApp.controller('adminPostCrtl', function($scope,$rootScope,$window,$document, $q,
                                                 geolocation,captureService,
                                                 shopInfoService, userSessionService,
                                                 $ionicModal,$ionicLoading,$ionicScrollDelegate,$navigate,$ionicHistory) {
    // $scope.clientHeight = angular.element($document).height()-40+'px';//($window.innerHeight-40)+'px';
    $scope.isNewRecord = "block";
    $scope.updateRecord = "none";
    $scope.isHalfEdit = false;
    $scope.formData = {};
	$scope.landmarkImage = "images/icons/camera.png";
    $scope.$on('$ionicView.enter', function() {
        $rootScope.$broadcast('updateNavBar',{showFB:false,searchshop:false,map_all:false,showAR:false});
    })
    var watchId;
    var userPostcode = "";

    var geoToJSON = function(position) {
        if (position && JSON.stringify(position) == '{}') {
            var clean = {};
            clean.timestamp = position.timestamp;
            clean.coords = {};
            clean.coords.latitude = position.coords.latitude;
            clean.coords.longitude = position.coords.longitude;
            clean.coords.altitude = position.coords.altitude;
            return clean;
        } else {
            return position;
        }
    }

    function initPage(){
        if ((userSessionService.username||'').match(/[0-9]{5}/)) {
            userPostcode = userSessionService.username;
        }
        initData();
    	shopInfoService.getDropdownShopType(
                function(sResult){
                    if(sResult.error || !sResult.result){
                        console.log('call getDropdownSType Error');
                    }else{
                        $scope.$applyAsync(function() {
//                        	console.log('ccvvvvv'+JSON.stringify(sResult.result.sTypeResults))
                            $scope.lov_stype = sResult.result.sTypeResults;
                            $scope.lov_stype.forEach(function (type){
                                if ($scope.checkEnglishLanguage) {
                                    type.desc = type.descriptionEng || type.description;
                                } else {
                                    type.desc = type.description;
                                }
                            })
                        });
                    }
                }
            );
        watchId = geolocation.watchPosition(function (position) {
        	console.log('WATCH POSITION', position);
            $scope.position = geoToJSON(position);

            try{
                var strPosition = {};
                var nearByCriteria = {};
                nearByCriteria["mode"] = 'N';
                strPosition["lat"] = position.coords.latitude;
                strPosition["lng"] = position.coords.longitude;
                nearByCriteria["geolocation"] = strPosition;
//                 shopInfoService.getDropdownShop(
//                     nearByCriteria
//                     , function (r) {
//                         if (r.error || !r.result) console.log('call getDropdownShop Error');
//                         else if (r.result) {
// //                            console.log('changeSearchMode result: ' + JSON.stringify(r.result));
//                             $scope.lov_shop = r.result.shopResults;

//                         }
//                     });
            }catch(err){
                console.log('watchPosition Error:'+err);
            }

        }, function(){
            console.log("Not change Geolocation!");
        },{ timeout: 10000 });
    }
    function onSuccess(imageData) {
        $scope.$applyAsync(function(){
            console.log(imageData.length);
            $scope.postOfficeImage = "data:image/jpeg;base64,"+imageData;
            $scope.postOfficeImageBase64 = imageData;
        });
    }

    function onFail(message) {
        navigator.notification.alert(
            'Failed because: ' + message,   // message
            function(){},                     // callback
            $scope.msg.lbl_alert,               // title
            $scope.msg.lbl_alert_ok             // buttonName
        );
    }

    function hoursFromString(str) {
        var d = new Date(0), sp = (str||"").split(":");
        if (sp.length == 2) {
            d.setHours(sp[0]*1);
            d.setMinutes(sp[1]*1);
            return d;
        } else {
            return null;
        }
    }

    function stringFromHours(dateObj) {
        return dateObj ? dateObj.toTimeString().substring(0, 5) : null;
    }

    function initData(){
        $scope.formData.postCode = userPostcode;
        $scope.formData.shopId = "";
        $scope.formData.sType = null;
        $scope.formData.name = "";
		$scope.formData.nameEng = "";
        $scope.formData.address = "";
		$scope.formData.addressEng = "";
        $scope.formData.phone = "";
        $scope.formData.fax = "";
        $scope.formData.htmlDescription = "";
		$scope.formData.parking = null;
        $scope.postOfficeImage = "images/icons/camera.png";
        $scope.postOfficeImageBase64 = "";
        //mongo version + landmark
        $scope.landmarkList = null;
        $scope.hours = {};
        delete $scope.formData.weekdayOpen;
        delete $scope.formData.weekdayClose;
        ['sat', 'sun', 'holiday', 'subholiday'].forEach(function(day){
            delete $scope.formData[day+'Stop'];
            delete $scope.formData[day+'Open'];
            delete $scope.formData[day+'Close'];
        })

        setTimeout(function(){
            $ionicScrollDelegate.scrollTop();
        }, 500);
    }

	function initData2(param) {
        $scope.isHalfEdit = false;
		$scope.formData.shopId = param.shopId;
		$scope.formData.sType = $scope.lov_stype.filter(function(e){
            return e.stypeId == param.shopTypeId;
        })[0];
		$scope.formData.name = param.name;
		$scope.formData.nameEng = param.nameEng;
		$scope.formData.address = param.address;
		$scope.formData.addressEng = param.addressEng;
		$scope.formData.phone = param.phone;
		$scope.formData.fax = param.fax;
        $scope.formData.htmlDescription = param.htmlDescription;
		$scope.formData.parking = ""+param.parking;
        $scope.formData.weekdayOpen = hoursFromString(param.weekdayOpen);
        $scope.formData.weekdayClose = hoursFromString(param.weekdayClose);
        ['sat', 'sun', 'holiday', 'subholiday'].forEach(function(day){
            $scope.formData[day+'Stop'] = param[day+'Stop']
            $scope.formData[day+'Open'] = hoursFromString(param[day+'Open']);
            $scope.formData[day+'Close'] = hoursFromString(param[day+'Close']);
        })
		$scope.postOfficeImage = param.imageUrl;
        $scope.postOfficeImageBase64 = "";
        //mongo version + landmark
        $scope.landmarkList = param.landmarks;
	}

    $scope.cancel = function() {
        var ok = confirm($scope.msg.lbl_go_back_first + '?');
        if (ok) {
            $ionicHistory.nextViewOptions({
              disableAnimate: true,
              disableBack: true
            });
            $navigate.go('/');
        }
    }

	$scope.getShopInfo = function(postcode) {
        $scope.showUpdateShopInfo = false;
        $ionicLoading.show();
		shopInfoService.getShopInfoByPostcode({postcode:$scope.formData.postCode}, function(r){
			if (r.error || !r.result){
				navigator.notification.alert(r.error);
            } else if (Array.isArray(r.result.shopInfo)) {
                $scope.isHalfEdit = true;
                $scope.editShops = r.result.shopInfo;
			} else if (r.result) {
				console.log(r.result);
				initData2(r.result.shopInfo);
				$scope.showUpdateShopInfo = true;
                // $scope.initLandmark(postcode);
                // $scope.shared.landPostcode=$scope.formData.postCode;
				$scope.$applyAsync(function(){
				});
			}
            $ionicLoading.hide();
		});
	}

    $scope.selectFullEdit = function() {
        if (!$scope.formData.selectedShop) return;
        var confirm = window.confirm($scope.msg.lbl_location_half_confirm + "\n" + $scope.formData.selectedShop.name);
        if (confirm && $scope.formData.selectedShop && $scope.formData.selectedShop.shopId) {
            initData2($scope.formData.selectedShop);
            $scope.showUpdateShopInfo = true;
            // $scope.initLandmark(postcode);
            // $scope.shared.landPostcode=$scope.formData.postCode;
            $scope.$applyAsync(function(){
                $scope.formData.selectedShop = null;
            });
        }
    }

    $scope.blurClearData = function() {
        if ($scope.showUpdateShopInfo && $scope.formData.postCode == "") {
            initData();
            // initLandmark();
            $scope.showUpdateShopInfo = false;
        }
    }

    $scope.$on('language-switch', function(val){
        if ($scope.lov_stype) {
            $scope.lov_stype.forEach(function (type) {
                if (val == 'th') type.desc = type.description;
                else if (val == 'en') type.desc = type.descriptionEng || type.description;
            })
        }
    })

    $scope.addNew_Click = function(mode){
//        console.log('addNew_Click');
        if (mode == 'new') {
            $scope.isNewRecord = "block";
            $scope.updateRecord = "none";
        } else if (mode == 'update') {
            $scope.isNewRecord = "none";
            $scope.updateRecord = "block";
        }
    }

    $scope.takePhotoPostOffice = function(){
        captureService.cameraCapture(onSuccess
            ,onFail
            ,{ quality: 75
                ,encodingType: Camera.EncodingType.JPEG
                ,destinationType : Camera.DestinationType.DATA_URL
                ,correctOrientation : true
                ,targetWidth: 800
                ,targetHeight: 800});
    }

    function prepareSaveObj() {
        var saveObj = {
            userRef : userSessionService.userRef,
            userId : userSessionService.userId
        };
        saveObj["postcode"] = $scope.formData.postCode;
        saveObj["shopTypeId"] = $scope.formData.sType.stypeId;
        saveObj["name"] = $scope.formData.name;
        saveObj["nameEng"] = $scope.formData.nameEng;
        saveObj["address"] = $scope.formData.address;
        saveObj["addressEng"] = $scope.formData.addressEng;
        saveObj["phone"] = $scope.formData.phone;
        saveObj["fax"] = $scope.formData.fax;
        saveObj["weekdayOpen"] = stringFromHours($scope.formData['weekdayOpen']);
        saveObj["weekdayClose"] = stringFromHours($scope.formData['weekdayClose']);
        ['sat', 'sun', 'holiday', 'subholiday'].forEach(function(day){
            saveObj[day+'Stop'] = $scope.formData[day+'Stop']
            saveObj[day+'Open'] = stringFromHours($scope.formData[day+'Open']);
            saveObj[day+'Close'] = stringFromHours($scope.formData[day+'Close']);
        })
        if ($scope.formData.parking) {
            saveObj["parking"] = $scope.formData.parking == "true";
        }
        if ($scope.position && $scope.position.coords) {
            saveObj["geolocation"] = angular.copy($scope.position);
        }
        if ($scope.postOfficeImageBase64){ 
            saveObj["image"] = $scope.postOfficeImageBase64; 
        };
        //mongo version + landmark
        if ($scope.landmarkList) {
            saveObj["landmarks"] = $scope.landmarkList.map(function(e){
                return {
                    landmarkName: e.landmarkName, 
                    landmarkNameEng: e.landmarkNameEng, 
                    image: e.landmarkImage
                };
            });
        }
        return saveObj;
    }

    $scope.btnEdit_Click = function(){
	    console.log('edit click', $scope.position);
        if (!userSessionService.isLogin) {
            alert("Please Login");
            return;
        }
        if (!$scope.formData.shopId) return;
        try{
        var saveObj = prepareSaveObj();
        saveObj.shopId = $scope.formData.shopId;
        console.log(saveObj);
        if (!saveObj.geolocation || !saveObj.geolocation.coords || !Number.isFinite(saveObj.geolocation.coords.latitude * 1)) {
            var ok = confirm($scope.msg.msg_warn_nogeolocation);
            if (!ok) return;
        }

		// $scope.prepareSaveLandmark(saveObj);
		console.log(JSON.stringify(saveObj));
        // return;
        $ionicLoading.show();
        shopInfoService.updateShopLocationAndImage(
            saveObj
            ,function(r){
                $ionicLoading.hide();
				console.log(JSON.stringify(r));
                if (r.error || !r.result){
                    navigator.notification.alert($scope.msg.msg_save_fail);
                } else if (r.result) {
                    $scope.$applyAsync(function(){
                        navigator.notification.alert($scope.msg.msg_save_ok);
                        initData();
                        // clearLandmark();
                    });
                }
            });
        }catch(err){console.log('Edit_Click Error:'+err);}
    }

    $scope.btnSave_Click = function(){
        if (!userSessionService.isLogin()) {
            alert("Please Login");
            return;
        }
        try{
            var saveObj = prepareSaveObj();
			// $scope.prepareSaveLandmark(saveObj);
            $ionicLoading.show();
            shopInfoService.saveShopLocationAndImage(
                saveObj
                ,function(r){
                    $ionicLoading.hide();
                    if (r.error || !r.result){
                        navigator.notification.alert($scope.msg.msg_save_fail);
                    } else if (r.result) {
                        $scope.$applyAsync(function(){
                            navigator.notification.alert($scope.msg.msg_save_ok);
                            initData();
                            // clearLandmark();
                        });
                    }
                });
        }catch(err){console.log('Save_Click Error:'+err);}
    }

    $scope.$on('$destroy', function() {
    	geolocation.clearWatch(watchId);
    });

    ////////// service hour modal ////////

    $scope.callServicehourModal = function(title) {
        angular.extend($scope.hours, $scope.formData);
        return $q(function(resolve, reject){
            var _modal = null;
            $ionicModal.fromTemplateUrl('modals/servicehourmodal.html', {
                scope: $scope
            }).then(function(modal) {
                _modal = modal;
                angular.extend(_modal.scope, {title:title});
                _modal.scope.closeModal = function(_value) {
                    _modal.hide().then(function(){
                        _modal.remove();
                    });
                    resolve(null);
                    //if (_value) resolve(JSON.parse(_value)); else reject(null);
                };
                _modal.show();
            }).catch(function(e){
                console.log('catch1 '+e);
                reject(e);
            });
        });  
    }

    $scope.saveHours = function() {
        if (!$scope.hours) return;
        ['sat','sun','holiday','subholiday'].forEach(function (day){
            $scope.formData[day+'Open'] = null;
            $scope.formData[day+'Close'] = null;
            if (!$scope.hours[day+'Stop']) {
                $scope.formData[day+'Open'] = $scope.hours[day+'Open'];
                $scope.formData[day+'Close'] = $scope.hours[day+'Close'];
            }
            $scope.formData[day+'Stop'] = $scope.hours[day+'Stop'];
        })
        $scope.hours = {};
    }
    

	////////// landmark popover ////////

    //mongo version
    $scope.addLandmarkModal = function(title) {
        $scope.shared = {};
        return $q(function(resolve, reject){
            var _modal = null;
            $ionicModal.fromTemplateUrl('modals/landmarkedit.html', {
                scope: $scope
            }).then(function(modal) {
                _modal = modal;
                angular.extend(_modal.scope, {title:title});
                _modal.scope.closeModal = function(_value) {
                    _modal.hide().then(function(){
                        _modal.remove();
                    });
                    resolve(null);
                    //if (_value) resolve(JSON.parse(_value)); else reject(null);
                };
                _modal.show();
            }).catch(function(e){
                console.log('catch1 '+e);
                reject(e);
            });
        });  
    }

    $scope.addLandmark = function() {
        var land = $scope.shared.clandmark;
        if (typeof land != 'object' || !land.landmarkName) return false;
        if (!$scope.landmarkList) $scope.landmarkList = [];
        $scope.landmarkList.push(land);
        $scope.shared.clandmark = {};
        return true;
    }
    /*
    $scope.addLandmarkModal = function(title) {
        return $q(function(resolve, reject){
            var _modal = null;
            $ionicModal.fromTemplateUrl('modals/landmarkedit.html', {
                scope: $scope
            }).then(function(modal) {
                _modal = modal;
                angular.extend(_modal.scope, {title:title});
                _modal.scope.closeModal = function(_value) {
                    _modal.hide().then(function(){
                        _modal.remove();
                    });
                    resolve(null);
                    //if (_value) resolve(JSON.parse(_value)); else reject(null);
                };
                _modal.show();
            }).catch(function(e){
                console.log('catch1 '+e);
                reject(e);
            });
        });
    }
    
    function clearLandmark() {
        $scope.shared = {};
        $scope.shared.clandmark = {};
        $scope.showlandmark = false; //phone only
        $scope.searchLandmarkList = [];
        $scope.landmarkList = [];
        $scope.landmarkIdList = [];
    }
    clearLandmark();

	$scope.initLandmark = function(postcode) {
		console.log(postcode);
		function showmodal() {
			$scope.showlandmark = true;
		// 	var md = $modal({scope: $scope.$new(), title:$scope.msg.lbl_post_landmark + ' ' + $scope.postCode, contentTemplate:'modal_landmark.html', show:true});
		// 	md.$scope.nodrop = true;
		}
		if ($scope.shared.landPostcode == postcode) {
			//must not search
			showmodal();
		} else if (!postcode) {
			$scope.landmarkList = [];
			$scope.landmarkIdList = [];
			showmodal();
		} else {
			shopInfoService.searchLandmark({postcode:postcode},function(r){
				$scope.showlandmark = true;
				if (r.result) {
					console.log(r.result);
					$scope.landmarkList = r.result.landmarks;
					$scope.landmarkIdList = $scope.landmarkList.map(function(e){return e.landmarkId});
					showmodal();
				} else if (r.error) {
					console.log('error');
				}
			});
		}
	}
	$scope.prepareSaveLandmark = function(saveobj) {
		if ($scope.shared.landPostcode && $scope.shared.landPostcode != saveobj.postcode) {
			console.log('not change landmark');
			return;
		}
		var idlist = $scope.landmarkList.map(function(e){return e.landmarkId});
		var deleteList = [];
		$scope.landmarkIdList.forEach(function(i){
			if (idlist.indexOf(i) < 0) deleteList.push(i);
		});
		var landList = [];
		$scope.landmarkList.forEach(function(e){
			if (!e.landmarkId) landList.push({landmarkName:e.landmarkName, landmarkNameEng:e.landmarkNameEng, image:e.landmarkImage});
		});
		saveobj.landmarks = landList;
		saveobj.removeLandmarkIds = deleteList;
		console.log('prepare ->' + JSON.stringify(saveobj));
	}
	$scope.searchLandmarkQ = function($viewValue) {
		console.log($viewValue);
		if (!$viewValue || typeof $viewValue != 'string') return [];
		return $q(function(resolve, reject){
			console.log('call rpc');
			shopInfoService.searchLandmark({name:$viewValue}, function(r){
				console.log('will resolve' + r);
				resolve(r);
			});
		}).then(function(r){
			if (r.result) {
				console.log(r.result);
				return r.result.landmarks;
			} else if (r.error) {
				console.log('error');
				return [];
			}
		},function(r){console.log('reject')});
	}

    /////////// ionic version of searchLandmark ///////////
    $scope.searchLandmarkNormal = function($viewValue) {
        var promise = $scope.searchLandmarkQ($viewValue)
        if (promise.then) {
            promise.then(function(arr){
                console.info(arr);
                $scope.shared.searchLandmarkResult = arr;
            })
        }
    }

	$scope.takePhotoLandmark = function() {
		captureService.cameraCapture(
			function(imageData) {
				$scope.$applyAsync(function(){
					$scope.shared.clandmark.landmarkImage = imageData;
				});
			}
            ,onFail
            ,{ quality: 45
                ,encodingType: Camera.EncodingType.JPEG
                ,destinationType : Camera.DestinationType.DATA_URL
                ,targetWidth: 320
                ,targetHeight: 240});
	}

	$scope.addLandmark = function() {
		var land = $scope.shared.clandmark;
		if (typeof land != 'object' || !land.landmarkName) return false;
		if (land.landmarkId && $scope.landmarkList.map(function(e){return e.landmarkId}).indexOf(land.landmarkId) >= 0) {
			alert('duplicate');
			return false;
		}
		$scope.landmarkList.push(land);
		$scope.shared.clandmark = {};
		return true;
	}
    */

    


    //onload
    // if(userSessionService.isLogin()){
        initPage();
    // }else{
        //baseCtrl
        // $scope.confirmLogin(true);
    // }
});
