'use strict';

postLensApp.controller('amapCtrl', function($scope, geolocation, selected_shop_DataModel, facebook, uiGmapGoogleMapApi, $stateParams) {

	$scope.updateShop($stateParams.id);

	$scope.pageName = 'แผนที่';
	$scope.placeName = "ปณ สาทร";

	$scope.traMode = '';//DRIVING
	if(angular.isUndefined($scope.isShowDirectionStep)){
		$scope.isShowDirectionStep = true;
	}
	
	// //for phone
	// $scope.showMap = true;
	// $scope.showMode = "Step";
	// $scope.$watch('showMap', function(newValue, oldValue) { 
	// 	if($scope.showMap){
	// 		$scope.showMode = "Step";
	// 	}else{
	// 		$scope.showMode = "Map";
	// 	}
	// });

	$scope.buttonClicked = function(i) {
		var modes = ['DRIVING', 'WALKING', 'TRANSIT'];
		$scope.calcDirection(modes[i]);
	}

	$scope.toggleMap = function(i) {
		if (i === 0) $scope.shopMap.showMap = false;
		else $scope.shopMap.showMap = true;
		$scope.$apply();
	}

	$scope.mapOptions = {
		zoom: 17,
		streetViewControl: false
	};
	$scope.shopMap = {showMap:true, center:{latitude:14.0, longitude:101.0}, zoom:17, control:{}};

    ///ionic
    var fbwatch;
    $scope.$on('$ionicView.leave', function() {
    	fbwatch();
    })
    $scope.$on('$ionicView.enter', function() {
    	fbwatch = $scope.$on('sharefb', function(){
        	$scope.facebookShareAddress();
    	})
    })
    
    $scope.facebookShareAddress = function(){
        console.log("do FB share...");
        facebook.share($scope.shopInfo.placeName
            //, 'https://maps.google.de/maps?q='+selected_shop_DataModel.selectedShop.geolocation.lng+','+selected_shop_DataModel.selectedShop.geolocation.lat+'&z=16&t=m'
			, 'https://www.google.com/maps/@'+$scope.shopInfo.geolocation.lat+','+$scope.shopInfo.geolocation.lng+',17z'
            , 'https://mobile.thailandpost.com/TP/media/resources/images/sharemap.png'
            , $scope.shopInfo.addr
            , '');
    }

	$scope.getGeo = function() {
		geolocation.getCurrentPosition(
            function(position) { },
            function() {
                navigator.notification.alert(
                    $scope.msg.call_geolocation_error,
                    function(){},
                    $scope.msg.lbl_alert,
                    $scope.msg.lbl_alert_ok);
		    },
            { maximumAge: 10000, timeout: 10000, enableHighAccuracy: true });

	}

	function onSuccessGeo(position) {
		var directionsServiceOpt = {};
		var directionsDisplayOpt = {suppressMarkers: true};
		var routeOpt = {
			travelMode: $scope.traMode//google.maps.TravelMode[$scope.traMode]
		};
		var startMarkerOpt = {};
		var endMarkerOpt = {icon: 'images/icons/Marker-Flag.png'};
		
		if(selected_shop_DataModel.selectedShop){
            geolocation.getDirection($scope, position.coords.latitude, position.coords.longitude
                , $scope.shopInfo.geolocation.lat
                , $scope.shopInfo.geolocation.lng
                , $scope.shopMap.control.getGMap()
                , directionsServiceOpt, directionsDisplayOpt
                , routeOpt, startMarkerOpt, endMarkerOpt, $scope.isShowDirectionStep);
		}else{
            navigator.notification.alert(
                $scope.msg.null_selected_location,
                function(){},
                $scope.msg.lbl_alert,
                $scope.msg.lbl_alert_ok);
		}
	    
	  }
	
	function onErrorGeo(){
        navigator.notification.alert(
            $scope.msg.call_geolocation_error,
            function(){},
            $scope.msg.lbl_alert,
            $scope.msg.lbl_alert_ok);

		  var directionsServiceOpt = {};
			var directionsDisplayOpt = {suppressMarkers: true};
			var routeOpt = {
				travelMode: google.maps.TravelMode[$scope.traMode]
			};
			var startMarkerOpt = {};
			var endMarkerOpt = {icon: 'images/test/Marker-Flag.png'};
			
			if(selected_shop_DataModel.selectedShop){
				geolocation.getDirection($scope, 13.885954, 100.574105
			    		, $scope.shopInfo.geolocation.lat
			    		, $scope.shopInfo.geolocation.lng
			    		, $scope.shopMap.control.getGMap()
			    		, directionsServiceOpt, directionsDisplayOpt
			    		, routeOpt, startMarkerOpt, endMarkerOpt, $scope.isShowDirectionStep);
			}else{
                //navigator.notification.
                alert(
                    $scope.msg.null_selected_location,
                    function(){},
                    $scope.msg.lbl_alert,
                    $scope.msg.lbl_alert_ok);
			}
	  }
	
	
	$scope.calcDirection = function(travelMode){
    	if (!$scope.shopInfo || !$scope.shopInfo.geolocation) {
			navigator.notification.alert(
				$scope.msg.lbl_alert_no_geolocation,
				function(){},
				$scope.msg.lbl_alert,
				$scope.msg.lbl_alert_ok);
    		return;
    	}
		console.log("calcDirection.."+travelMode);
		if($scope.traMode != travelMode){
			$scope.traMode = travelMode;
			geolocation.getCurrentPosition(
                onSuccessGeo,
                onErrorGeo,
                { maximumAge: 10000, timeout: 10000, enableHighAccuracy: true });
		}
	}

    function startMapDirsction(travelMode){
    	$scope.calcDirection(travelMode);
        // console.log("calcDirection.."+travelMode);
        // if($scope.traMode != travelMode){
        //     $scope.traMode = travelMode;
        //     geolocation.getCurrentPosition(
        //         onSuccessGeo,
        //         onErrorGeo,
        //         { maximumAge: 10000, timeout: 10000, enableHighAccuracy: true });
        // }
    }

    $scope.openMapsApp = function() {
    	if (!$scope.shopInfo.geolocation) return;
    	var latlng = $scope.shopInfo.geolocation.lat+","+$scope.shopInfo.geolocation.lng;
    	var url = "https://www.google.com/maps/dir/?api=1&destination="+latlng;

    	try {
			if (device.platform.toUpperCase() === 'ANDROID') {
				navigator.app.loadUrl(url, { openExternal: true });
			} else {
				window.open(url, '_system');
			}
		} catch (e) {}

    }

    console.log($scope.shopInfo);
    if ($scope.shopInfo) {
    	uiGmapGoogleMapApi.then(function(_maps){
    		startMapDirsction("DRIVING");
    	})
    } else {
    	var _shopReady = $scope.$on('shopReady', function(ev, v){
    		console.info('shopReady', v);
    		startMapDirsction("DRIVING");
    		_shopReady();
    	})
    }
	// if (selected_shop_DataModel.selectedShop
	// 	&& selected_shop_DataModel.selectedShop.geolocation
	// 	&& selected_shop_DataModel.selectedShop.geolocation.lat) {
		// setTimeout(function(){startMapDirsction("DRIVING");},15000);
	// } else {
	// 	navigator.notification.alert(
	// 		$scope.msg.lbl_alert_no_geolocation,
	// 		function(){},
	// 		$scope.msg.lbl_alert,
	// 		$scope.msg.lbl_alert_ok);
	// }

});
