'use strict';

postLensApp.controller('amapCtrl', function($scope, geolocation, selected_shop_DataModel, facebook) {
	$scope.pageName = 'แผนที่';
	$scope.placeName = "ปณ สาทร";

	$scope.traMode = '';//DRIVING
	if(angular.isUndefined($scope.isShowDirectionStep)){
		$scope.isShowDirectionStep = false;
	}
	
	//for phone
	$scope.showMap = true;
	$scope.showMode = "Step";
	$scope.$watch('showMap', function(newValue, oldValue) { 
		if($scope.showMap){
			$scope.showMode = "Step";
		}else{
			$scope.showMode = "Map";
		}
	});

	$scope.buttonClicked = function(i) {
		var modes = ['DRIVING', 'WALKING', 'TRANSIT'];
		calcDirection($scope.traMode = modes[i]);
	}
	
	$scope.mapOptions = {
		zoom:16,
	    mapTypeId: google.maps.MapTypeId.ROADMAP,
	    streetViewControl: false,
	    center: new google.maps.LatLng(13.885954, 100.574105)
	};

    $scope.facebookShareAddress = function(){
        console.log("do FB share...");
        facebook.share(selected_shop_DataModel.selectedShop.placeName
            //, 'https://maps.google.de/maps?q='+selected_shop_DataModel.selectedShop.geolocation.lng+','+selected_shop_DataModel.selectedShop.geolocation.lat+'&z=16&t=m'
			, 'https://www.google.com/maps/@'+selected_shop_DataModel.selectedShop.geolocation.lat+','+selected_shop_DataModel.selectedShop.geolocation.lng+',16z'
            , 'https://mobile.thailandpost.com/TP/media/resources/images/sharemap.png'
            , selected_shop_DataModel.selectedShop.addr
            , '');
    }

	$scope.getGeo = function() {
		geolocation.getCurrentPosition(
            function(position) { },
            function() {
                navigator.notification.alert(
                    $scope.msg.call_geolocation_error,
                    function(){},
                    $scope.msg.lbl_alert,
                    $scope.msg.lbl_alert_ok);
		    },
            { maximumAge: 10000, timeout: 10000, enableHighAccuracy: true });

	}

	function onSuccessGeo(position) {
		var directionsServiceOpt = {};
		var directionsDisplayOpt = {suppressMarkers: true};
		var routeOpt = {
			travelMode: google.maps.TravelMode[$scope.traMode]
		};
		var startMarkerOpt = {};
		var endMarkerOpt = {icon: 'images/icons/Marker-Flag.png'};
		
		if(selected_shop_DataModel.selectedShop){
            geolocation.getDirection($scope, position.coords.latitude, position.coords.longitude
                , selected_shop_DataModel.selectedShop.geolocation.lat
                , selected_shop_DataModel.selectedShop.geolocation.lng
                , $scope.shopMap
                , directionsServiceOpt, directionsDisplayOpt
                , routeOpt, startMarkerOpt, endMarkerOpt, $scope.isShowDirectionStep);
		}else{
            navigator.notification.alert(
                $scope.msg.null_selected_location,
                function(){},
                $scope.msg.lbl_alert,
                $scope.msg.lbl_alert_ok);
		}
	    
	  }
	
	function onErrorGeo(){
        //navigator.notification.
        alert(
            $scope.msg.call_geolocation_error,
            function(){},
            $scope.msg.lbl_alert,
            $scope.msg.lbl_alert_ok);

		  var directionsServiceOpt = {};
			var directionsDisplayOpt = {suppressMarkers: true};
			var routeOpt = {
				travelMode: google.maps.TravelMode[$scope.traMode]
			};
			var startMarkerOpt = {};
			var endMarkerOpt = {icon: 'images/test/Marker-Flag.png'};
			
			if(selected_shop_DataModel.selectedShop){
				geolocation.getDirection($scope, 13.885954, 100.574105
			    		, selected_shop_DataModel.selectedShop.geolocation.lat
			    		, selected_shop_DataModel.selectedShop.geolocation.lng
			    		, $scope.shopMap
			    		, directionsServiceOpt, directionsDisplayOpt
			    		, routeOpt, startMarkerOpt, endMarkerOpt, $scope.isShowDirectionStep);
			}else{
                navigator.notification.alert(
                    $scope.msg.null_selected_location,
                    function(){},
                    $scope.msg.lbl_alert,
                    $scope.msg.lbl_alert_ok);
			}
	  }
	
	
	$scope.calcDirection = function(travelMode){
		console.log("calcDirection.."+travelMode);
		if($scope.traMode != travelMode){
			$scope.traMode = travelMode;
			geolocation.getCurrentPosition(
                onSuccessGeo,
                onErrorGeo,
                { maximumAge: 10000, timeout: 10000, enableHighAccuracy: true });
		}
	}

    function startMapDirsction(travelMode){
        console.log("calcDirection.."+travelMode);
        if($scope.traMode != travelMode){
            $scope.traMode = travelMode;
            geolocation.getCurrentPosition(
                onSuccessGeo,
                onErrorGeo,
                { maximumAge: 10000, timeout: 10000, enableHighAccuracy: true });
        }
    }

	if (selected_shop_DataModel.selectedShop
		&& selected_shop_DataModel.selectedShop.geolocation
		&& selected_shop_DataModel.selectedShop.geolocation.lat) {
		setTimeout(function(){startMapDirsction("DRIVING");},3000);
	} else {
		navigator.notification.alert(
			$scope.msg.lbl_alert_no_geolocation,
			function(){},
			$scope.msg.lbl_alert,
			$scope.msg.lbl_alert_ok);
	}

});
