'use strict';
postLensApp.controller('changePasswordCtrl', function($scope, $navigate, userProfileService, utilService, userSessionService) {
	
	$scope.formData = {};

	$scope.validate = function() {
		if (!$scope.formData.currentPassword) {
			return {error:$scope.msg_validate_password};
		} else if (!$scope.formData.newPassword1 || !$scope.formData.newPassword2) {
			return {error:$scope.msg_validate_password};
		} else if ($scope.formData.newPassword1 != $scope.formData.newPassword2) {
			return {error:$scope.msg_validate_equalpassword};
		} else {
			return {result:$scope.formData.newPassword1};
		}
	}
	
    function showUserProfile(){
    	var userData = {userId : userSessionService.userId};
    	
    	userProfileService.getUserProfile(userData, function(r){
			if(r.error || !r.result) console.log('call getUserProfile Error');
			else if(r.result){
				var profile = r.result.userProfile;
				if (profile) {
					$scope.formData = {};
					$scope.username = profile.username;
					console.log(JSON.stringify(profile));
				}
			}
		});
    }
    
	$scope.changePassword = function() {
		var arg = {}, newPassword;
		newPassword = $scope.validate().result;
		if (!newPassword) return;
		arg.username = $scope.username;
		arg.oldPassword = utilService.encodePassword($scope.formData.currentPassword);
		arg.newPassword = utilService.encodePassword(newPassword);
		userProfileService.changeUserPassword(arg, function(r){
			console.log('INNER METHOD' + JSON.stringify(arg)+JSON.stringify(r));
			if (r.error) {
				if (r.error == 'old_password_incorrect') navigator.notification.alert('Old password incorrect');
				else navigator.notification.alert('saveProfile error!');
			} else if(!r.result) {
				console.log('call changePassword no result');
			} else if(r.result && r.result.saveResult == "ok"){
                console.log("changePassword complete.");
                navigator.notification.alert($scope.msg.msg_success_profile);
            }else{
                alert('saveProfile error!');
            }
		});
	}
	
	if(userSessionService.isLogin()){
		showUserProfile();
	}else{
		//baseCtrl
		$scope.confirmLogin(true);
	}
});