'use strict';
postLensApp.controller('commentCtrl', function($scope, selected_shop_DataModel
		, shopInfoService, captureService, userSessionService,$window, userProfileService, $stateParams) {

	$scope.updateShop($stateParams.id);

	$scope.placeName = '';
    $scope.showWriter = false;
	$scope.id = 1;
	$scope.imageList = [];
    $scope.viewUserId = userSessionService.userId;
    $scope.shopId = $stateParams.id;

    $scope.formData = {score: 5};

    $scope.clickAddComment = function(){
        $scope.showWriter = !$scope.showWriter;
    }
	function showShopComment(){
//        console.log('shopId:'+selected_shop_DataModel.selectedShop.shopId);
		$scope.setLoading(true);
		shopInfoService.searchComment({shopId: $stateParams.id}
		,function(r){
			$scope.setLoading(false);
			if(r.error || !r.result) console.log('call searchComment Error');
			else if(r.result){
				$scope.$applyAsync(function(){
					$scope.comments = r.result.comments;
				});

			}
		});
	}

	$scope.attachImage = function(){
		captureService.cameraCapture(onSuccess
			,onFail
			,{ quality: 50
				,encodingType: Camera.EncodingType.JPEG
		  		,destinationType : Camera.DestinationType.DATA_URL
                ,targetWidth: 400
                ,targetHeight: 300 });
	}

	function onSuccess(imageData) {
		$scope.$applyAsync(function(){
			$scope.imageList.push(imageData);
		});
	}

	function onFail(message) {
	    navigator.notification.alert('Failed because: ' + message);
	}

	$scope.postComment = function(){

		if(userSessionService.isLogin()){
			var commentData = {
					userId : userSessionService.userId
						,shopId : $scope.shopId
						,userComment : $scope.formData.comment
						,score : $scope.formData.score
						,imageList : $scope.imageList
			}

//			console.log("commentData: "+JSON.stringify(commentData));

			$scope.setLoading(true);
			shopInfoService.saveShopComment(commentData
					, function(r){
						$scope.setLoading(false);
						if(r.error || !r.result) console.log('call saveShopComment Error');
						else if(r.result && r.result.saveResult == "ok"){
							console.log("saveShopComment complete.");
							$scope.formData.comment = '';
							$scope.formData.score = 5;
							$scope.imageList.length = 0;
							$scope.showWriter = false;
							showShopComment();
						}else{
                            navigator.notification.alert(
                                $scope.msg.lbl_alert_save_fail,   // message
                                alertDismissed,                     // callback
                                $scope.msg.lbl_alert,               // title
                                $scope.msg.lbl_alert_ok             // buttonName
                            );
//                            alert('saveComment error!');
						}
					});
		}else{
			//baseCtrl
			$scope.confirmLogin(false);
		}
	}

    $scope.addFollowingUser = function(comment){
//        console.log('addFollowingUser start');
//        console.log('userSessionService.userId:'+userSessionService.userId);
//        console.log('comment.followingId:'+comment.userId);
		if(userSessionService.isLogin()){
	        userProfileService.addFollowingUser(
	            {
	                userId:userSessionService.userId,
	                otherUserId:comment.userId,
	                notifyFollow:comment.notifyFollow
	            }
	            , function (r) {
	                if (r.result.saveResult) {
	                    $scope.$applyAsync(function(){
	                        comment.status = "W";
	                    });

	//                    console.log('addFollowingUser successfully');
	                    navigator.notification.alert(
	                        $scope.msg.lbl_alert_save_ok,   // message
	                        alertDismissed,                     // callback
	                        $scope.msg.lbl_alert,               // title
	                        $scope.msg.lbl_alert_ok             // buttonName
	                    );
	//                    alert(r.result.saveResult);
	                }
	            });
    	}
    }

    function alertDismissed() {
        // do something
    }
    $scope.addLikeComment = function(comment){
//        console.log('addLikeComment start');
//        console.log('userSessionService.userId:'+userSessionService.userId);
//        console.log('comment.commentId:'+comment.commentId);
//        console.log('comment.id:'+comment.userId);

		if(userSessionService.isLogin()){
	        userProfileService.addLikeComment(
	            {
	                userId:userSessionService.userId,
	                commentId:comment.commentId,
	                commentBy:comment.userId,
	                notifyComment:comment.notifyComment
	            }
	            , function (r) {
	                if(r.error || !r.result){
	//                    console.log('call addLikeComment Error');
	                }else{
	                    if(r.result.saveResult) {
	//                        console.log('addLikeComment successfully');
	                        navigator.notification.alert(
	                            $scope.msg.lbl_alert_save_ok,   // message
	                            alertDismissed,                     // callback
	                            $scope.msg.lbl_alert,               // title
	                            $scope.msg.lbl_alert_ok             // buttonName
	                        );
	//                        alert(r.result.saveResult);
	                    }
	                }
	            });
    	}
    }

	//onload
	showShopComment();




});
