'use strict';
postLensApp.controller('couponCtrl', function($scope, selected_shop_DataModel, shopInfoService, facebook,
         $stateParams, $ionicSlideBoxDelegate) {

    if ($stateParams.id) {
        $scope.updateShop($stateParams.id);
    }
    
	$scope.pageName = 'คูปอง';
	$scope.placeName = '';
    $scope.showWriter = false;
    $scope.score = 5;

    $scope.slidebox = {currentSlide: 0, currentRate: 5};

    $scope.slideChanged = function(index) {
        // $scope.slidebox.currentRate = $scope.getCurrentSlide().score;
    }

    $scope.getCurrentSlide = function() {
        return ($scope.couponList || {})[$scope.slidebox.currentSlide];
    }

    $scope.clickVote = function(){
        $scope.showWriter = !$scope.showWriter;
    }
    function alertDismissed() {
        // do something
    }
    $scope.vote = function(){
        shopInfoService.vote(
            {voteId:$scope.getCurrentSlide().couponId, score:$scope.score, method:'voteCoupon'},
            function(r){
                if(r.error || !r.result) {
					console.log('call voteCoupon Error');
					if (r.error == 'already_vote') {
						navigator.notification.alert($scope.msg.lbl_alert_already_vote);
					}
				}
				else if(r.requireLogin) {
					$scope.confirmLogin(false);
				}
                else if(r.result){
                    navigator.notification.alert(
                        $scope.msg.msg_save_ok,         // message
                        alertDismissed,                 // callback
                        $scope.msg.msg_title_alert,     // title
                        $scope.msg.lbl_alert_ok         // buttonName
                    );
                    $scope.$applyAsync(function(){
                        if(r.result.data[0].score){
                            $scope.getCurrentSlide().score = roundNumber(r.result.data[0].score,0);
                            $scope.slidebox.currentRate = roundNumber(r.result.data[0].score,0);
                            $scope.showWriter = !$scope.showWriter;
                        }
                    });
                }
            });
    }

	$scope.getCurCouponId = function() {
		return $scope.getCurrentSlide().couponId;
	}

    ///ionic
    var fbwatch;
    $scope.$on('$ionicView.leave', function() {
        fbwatch();
    })
    $scope.$on('$ionicView.enter', function() {
        fbwatch = $scope.$on('sharefb', function(){
            $scope.facebookShareCoupon();
        })
    })
    
    $scope.facebookShareCoupon = function(){
        console.log("do FB share Coupon...");
        facebook.share($scope.shopInfo.placeName
            , 'http://www.thailandpost.co.th/'
            , $scope.getCurrentSlide().couponImgUrl
            , $scope.shopInfo.addr
            , '');
    }

    function roundNumber(rnum, rlength) {
        var newnumber = Math.round(rnum * Math.pow(10, rlength)) / Math.pow(10, rlength);
        return newnumber;
    }

    function showCouponImage(){
        shopInfoService.searchCoupon(
            {shopId: $stateParams.id}
            ,function(r){
                if(r.error || !r.result) console.log('call searchCoupon Error');
                else if(r.result){
                    $scope.$applyAsync(function(){
                        $scope.couponList = r.result.coupons;
                        $scope.slidebox.currentRate = $scope.getCurrentSlide().score;
                        $ionicSlideBoxDelegate.update();
                    });
                }
            });
    }
    function showAllCoupon() {
        shopInfoService.searchAllCoupon(
        null
        ,function(r){
            try{
                if(r.error || !r.result) console.log('call searchAllCoupon Error');
                else if(r.result){
                    $scope.$applyAsync(function(){
                        $scope.couponList = r.result.coupons;
                        $scope.slidebox.currentRate = $scope.getCurrentSlide().score;
                        $ionicSlideBoxDelegate.update();
                    });
                }
            }catch(err){
//                alert('Error:'+err);
            }
        });
    }

    if ($stateParams.id) {
        showCouponImage();
    } else {
        showAllCoupon();
    }
});
