'use strict';
postLensApp.controller('followCtrl', function($scope, userProfileService, userProfile_DataModel, userSessionService) {
    $scope.pageName = $scope.msg.lbl_review;
    $scope.placeName = '';
    $scope.score = 1;
    $scope.id = 1;
    function alertDismissed() {
        // do something
    }
    userProfileService.getFollowList(
        {userId: userSessionService.userId}
    	,function(r){
            console.log(JSON.stringify(r));
    		if(r.error || !r.result) console.log('call getFollowList Error');
			else if(r.result){
				$scope.follows = r.result.followList;
			}
    	});

    $scope.postComment = function(){
//        alert("score: "+$scope.score)
    }
    $scope.confirmFollowerUser = function(profile){
//        console.log('blockFollowerUser start');
//        console.log('userSessionService.userId:'+userSessionService.userId);
//        console.log('profile.followerId:'+profile.followerId);
//        console.log('profile.username:'+profile.username);
        userProfileService.confirmFollowerUser(
            {
                userId:userSessionService.userId,
                otherUserId:profile.followerId
            }
            , function (r) {
                if (r.result.saveResult) {
                    $scope.$applyAsync(function(){
                        profile.status = "Y";
                    });

//                    console.log('confirmFollowerUser successfully');
                    if(r.result.saveResult == 'ok'){
                        navigator.notification.alert(
                            $scope.msg.lbl_alert_ok_follower,   // message
                            alertDismissed,                     // callback
                            $scope.msg.lbl_alert,               // title
                            $scope.msg.lbl_alert_ok             // buttonName
                        );
                    }else{
                        navigator.notification.alert(
                            $scope.msg.lbl_alert_fail_follower,   // message
                            alertDismissed,                     // callback
                            $scope.msg.lbl_alert,               // title
                            $scope.msg.lbl_alert_ok             // buttonName
                        );
                    }

//                    alert(r.result.saveResult);
                }
            });
    }
    $scope.blockFollowerUser = function(profile){
//        console.log('blockFollowerUser start');
//        console.log('userSessionService.userId:'+userSessionService.userId);
//        console.log('profile.followerId:'+profile.followerId);
//        console.log('profile.username:'+profile.username);
        userProfileService.blockFollowerUser(
            {
                userId:userSessionService.userId,
                otherUserId:profile.followerId
            }
            , function (r) {
                if (r.result.saveResult) {
                    $scope.$applyAsync(function(){
                        profile.status = "B";
                    });

//                    console.log('blockFollowerUser successfully');
                    if(r.result.saveResult == 'ok'){
                        navigator.notification.alert(
                            $scope.msg.lbl_alert_ok_follower,   // message
                            alertDismissed,                     // callback
                            $scope.msg.lbl_alert,               // title
                            $scope.msg.lbl_alert_ok             // buttonName
                        );
                    }else{
                        navigator.notification.alert(
                            $scope.msg.lbl_alert_fail_follower,   // message
                            alertDismissed,                     // callback
                            $scope.msg.lbl_alert,               // title
                            $scope.msg.lbl_alert_ok             // buttonName
                        );
                    }
//                    alert(r.result.saveResult);
                }
            });
    }
    $scope.deleteFollowUser = function(profile,index){
//        console.log('deleteFollowUser start');
//        console.log('userSessionService.userId:'+userSessionService.userId);
//        console.log('profile.followerId:'+profile.followerId);
//        console.log('profile.username:'+profile.username);

        userProfileService.deleteFollowUser(
            {
                userId:userSessionService.userId,
                otherUserId:profile.followerId
            }
            ,function(r){
                if(r.result.saveResult){
                    $scope.$applyAsync(function(){
                        if(index<$scope.follows.length){
                            $scope.follows[index].active = false;
                            $scope.follows.splice(index,1);
                        }
                    });
//                    console.log('deleteFollowUser successfully');
                    if(r.result.saveResult == 'ok'){
                        navigator.notification.alert(
                            $scope.msg.lbl_alert_del_ok_follower,   // message
                            alertDismissed,                     // callback
                            $scope.msg.lbl_alert,               // title
                            $scope.msg.lbl_alert_ok             // buttonName
                        );
                    }else{
                        navigator.notification.alert(
                            $scope.msg.lbl_alert_del_fail_follower,   // message
                            alertDismissed,                     // callback
                            $scope.msg.lbl_alert,               // title
                            $scope.msg.lbl_alert_ok             // buttonName
                        );
                    }
                    //alert(r.result.saveResult);
                }
            });
    }
});