'use strict';
postLensApp.controller('followingCtrl', function($scope, userProfileService, userProfile_DataModel, userSessionService) {
    $scope.pageName = $scope.msg.lbl_review;
    $scope.placeName = '';
    $scope.score = 1;
    $scope.id = 1;

    userProfileService.getFollowingList({userId: userSessionService.userId}
		,function(r){
            console.log(JSON.stringify(r));
			if(r.error || !r.result) console.log('call getFollowingList Error');
			else if(r.result){
				$scope.$applyAsync(function() {
					$scope.followings = r.result.followingList;
				});
			}
		});

    $scope.postComment = function(){
//        alert("score: "+$scope.score)
    }

    $scope.leaveFollowingUser = function(profile,index){
//        console.log('leaveFollowingUser start');
//        console.log('userSessionService.userId:'+userSessionService.userId);
//        console.log('profile.followerId:'+profile.followingId);
//        console.log('profile.username:'+profile.username);

        userProfileService.leaveFollowingUser(
            {
                userId:userSessionService.userId,
                otherUserId:profile.followingId
            }
            ,function(r){
                if(r.result.saveResult){
                    $scope.$applyAsync(function(){
                        if(index<$scope.followings.length){
                            $scope.followings[index].active = false;
                            $scope.followings.splice(index,1);
                        }
                    });
//                    console.log('leaveFollowingUser successfully');
                    if(r.result.saveResult == 'ok'){
                        navigator.notification.alert(
                            $scope.msg.lbl_alert_ok_following,   // message
                            alertDismissed,                     // callback
                            $scope.msg.lbl_alert,               // title
                            $scope.msg.lbl_alert_ok             // buttonName
                        );
                    }else{
                        navigator.notification.alert(
                            $scope.msg.lbl_alert_fail_following,   // message
                            alertDismissed,                     // callback
                            $scope.msg.lbl_alert,               // title
                            $scope.msg.lbl_alert_ok             // buttonName
                        );
                    }
//                    alert(r.result.saveResult);
                }
            });
    }
    $scope.deleteFollowingUser = function(profile,index){
//        console.log('deleteFollowingUser start');
//        console.log('userSessionService.userId:'+userSessionService.userId);
//        console.log('profile.followerId:'+profile.followingId);
//        console.log('profile.username:'+profile.username);

        userProfileService.deleteFollowingUser(
            {
                userId:userSessionService.userId,
                otherUserId:profile.followingId
            }
            ,function(r){
                if(r.result.saveResult){
                    $scope.$applyAsync(function(){
                        if(index<$scope.followings.length){
                            $scope.followings[index].active = false;
                            $scope.followings.splice(index,1);
                        }
                    });
//                    console.log('deleteFollowingUser successfully');
                    if(r.result.saveResult == 'ok'){
                        navigator.notification.alert(
                            $scope.msg.lbl_alert_del_ok_following,   // message
                            alertDismissed,                     // callback
                            $scope.msg.lbl_alert,               // title
                            $scope.msg.lbl_alert_ok             // buttonName
                        );
                    }else{
                        navigator.notification.alert(
                            $scope.msg.lbl_alert_del_fail_following,   // message
                            alertDismissed,                     // callback
                            $scope.msg.lbl_alert,               // title
                            $scope.msg.lbl_alert_ok             // buttonName
                        );
                    }
//                    alert(r.result.saveResult);
                }
            });
    }

});