'use strict';
postLensApp.controller('imageGalleryshopCtrl', function($scope, selected_shop_DataModel
		, shopInfoService, captureService, userSessionService, $stateParams, $ionicSlideBoxDelegate) {

	$scope.updateShop($stateParams.id);
	
    $scope.pageName = 'ห้องภาพ';
    $scope.placeName = '';
    $scope.imageList = [];
    
    $scope.slidebox = {currentSlide: 0};
    $scope.viewValue = {};

    $scope.getCurrentSlide = function() {
        return $scope.imageList[$scope.slidebox.currentSlide];
    }

	$scope.slideHasChanged = function(index) {
		$scope.slidebox.currentSlide = index;
		$scope.slideData = $scope.imageList[index];
	}

    $scope.getCurImageId = function() {
        return $scope.getCurrentSlide().imageId;
    }
    
    function showShopImage(){
    	shopInfoService.searchImageUpload({shopId: $stateParams.id}
	    	,function(r){
				if(r.error || !r.result) console.log('call searchImageUpload Error');
				else if(r.result){
					$scope.$applyAsync(function(){
						$scope.imageList = r.result.images;
						$ionicSlideBoxDelegate.update();
						if ($scope.imageList.length) {
							$scope.slideHasChanged(0);
						}
					})
					
				}
			});
    }
    
    $scope.captureImage = function(){
    	$scope.imgB64 = null;
    	if(userSessionService.isLogin()){
			captureService.cameraCapture(onSuccess 
				,onFail
				,{ quality: 50
					,encodingType: Camera.EncodingType.JPEG
			  		,destinationType : Camera.DestinationType.DATA_URL
	                ,targetWidth: 640
	                ,targetHeight: 640 });
		} else {
			$scope.confirmLogin(false);
		}
	}
    $scope.showPage = false;
    $scope.setShowPage = function(value) {
    	$scope.showPage = value;
    }

	function onSuccess(imageData) {
		$scope.$applyAsync(function(){
            $scope.showPage = true;          
			$scope.imgB64 = imageData;
                      
                      
		});
	}

	function onFail(message) {
	   // navigator.notification.alert('Failed because: ' + message);
        $scope.showPage = false;
	}
	
	$scope.postImage = function(){
		// alert($scope.viewValue.comment);
		if(userSessionService.isLogin()){
			var imageData = {
					userId : userSessionService.userId
						,shopId : $stateParams.id
						,comment : $scope.viewValue.comment
						,image : $scope.imgB64
			}
			
//			console.log("imageData: "+JSON.stringify(imageData));
			
			$scope.setLoading(true);
			shopInfoService.saveShopImage(imageData
					, function(r){
						$scope.setLoading(false);
						if(r.error || !r.result) console.log('call saveShopImage Error');
						else if(r.result && r.result.saveResult == "ok"){
//							console.log("saveShopImage complete.");
							$scope.viewValue.comment = '';
							$scope.imgB64 = null;
							$scope.imageList = null;
							showShopImage();
						}else{
                            navigator.notification.alert(
                                $scope.msg.lbl_alert_save_fail,   // message
                                alertDismissed,                     // callback
                                $scope.msg.lbl_alert,               // title
                                $scope.msg.lbl_alert_ok             // buttonName
                            );
                            //alert('saveComment error!');
						}
					});
		}else{
			//baseCtrl
			$scope.confirmLogin(false);
		}
	}
    function alertDismissed() {
        // do something
    }
	//onload
	showShopImage();
});
