'use strict';


postLensApp.controller({
    LoginController: function ($scope, $http, authService) {
        $scope.submit = function() {
            $http.post('auth/login').success(function() {
                authService.loginConfirmed();
            });
        }

    }

});

postLensApp.controller({
    ContentController: function ($scope, $http) {

        $scope.publicContent = [];
        $scope.restrictedContent = [];

        $scope.publicAction = function() {
            $http.post('data/public', $scope.publicData).success(function(response) {
                $scope.publicContent.push(response);
            });
        }

        $scope.restrictedAction = function() {
            $http.post('data/protected', $scope.restrictedData).success(function(response) {
                // this piece of code will not be executed until user is authenticated
                $scope.restrictedContent.push(response);
            });
        }

        $scope.logout = function() {
            $http.post('auth/logout').success(function() {
                $scope.restrictedContent = [];
            });
        }
    }

});

postLensApp.controller({
	FacebookController: function ($scope, $http, facebook) {

		$scope.facebookShare = function(){
			console.log("do FB share...");
			facebook.share($scope.fbShareName
					, $scope.fbShareLink
					, $scope.fbShareCap
					, $scope.fbShareDesc);
		}

		$scope.fbShareName = 'Test';
		$scope.fbShareLink = 'http://www.google.com';
		$scope.fbShareCap = 'Share';
		$scope.fbShareDesc = 'something';

		//----on load----
		facebook.init();
    }

});

/**
 * This module is used to simulate backend server for this demo application.
 */
angular.module('content-mocks',['ngMockE2E'])
    .run(function($httpBackend) {

        var authorized = false;
        $httpBackend.whenPOST('auth/login').respond(function(method, url, data) {
            authorized = true;
            return [200];
        });
        $httpBackend.whenPOST('auth/logout').respond(function(method, url, data) {
            authorized = false;
            return [200];
        });


        $httpBackend.whenPOST('data/public').respond(function(method, url, data) {
            return [200,'I have received and processed your data [' + data + '].'];
        });
        $httpBackend.whenPOST('data/protected').respond(function(method, url, data) {
            return authorized ? [200,'This is confidential [' + data + '].'] : [401];
        });

        //otherwise

        $httpBackend.whenGET(/.*/).passThrough();

    });
