'use strict';
postLensApp.controller('loginCtrl', function ($scope, $navigate, facebook
		, userSessionService, utilService, pushMessageService, $ionicHistory,$rootScope, $ionicLoading) {

	$scope.loginForm = {};

	$scope.loginFacebook = function(){
//        console.log('login facebook Start');
		if(!userSessionService.isLogin()){
			facebook.login(function(loginResp){
				console.log("loggedin facebook..", loginResp);
				facebook.me(function(meResp){
					// facebook.profilePic(function(picResp){

						var loginFacebookData = {
								email : meResp.email
								,token : loginResp.authResponse.accessToken
								,firstName : meResp.first_name
								,lastName : meResp.last_name
								,birthDate : meResp.birthday
								,address : meResp.location ? meResp.location.name : ""
								,language : $scope.i18n.language.locale
						};

						//get profile pic data
						if(!meResp.picture.data.is_silhouette){
//							console.log("has real image...");
							var profileImgUrl = meResp.picture.data.url;
							var profileImgData = utilService.getBase64ImageByUrl(profileImgUrl);

							if (profileImgData.length > 8000) {
								loginFacebookData.profileImgUrl = profileImgUrl;
							} else {

								loginFacebookData.profileImg = profileImgData;
							}
						}

						//push message
						loginFacebookData = pushMessageService.setRegIdToJSON(loginFacebookData);

						console.log("loginFacebookData: "+JSON.stringify(loginFacebookData));

						$ionicLoading.show();
						userSessionService.login(loginFacebookData
							, function(r){
								$ionicLoading.hide();
								if(!r.error && r.result && r.result.loginInfo){
//                                    console.log("result: "+JSON.stringify(r));
//									console.log("login complete.");
									userSessionService.setUserSession(
                                        r.result.loginInfo.username,
                                        r.result.loginInfo.userId,
                                        true,
                                        r.result.loginInfo.notifyComment,
                                        r.result.loginInfo.notifyFollow,
                                        r.result.loginInfo.userRef,
                                        r.result.loginInfo.isPostLensAdmin);

									$scope.$applyAsync(function(){
									$scope.toggle.checkComment = r.result.loginInfo.notifyComment == 'Y';
									$scope.toggle.checkFollow = r.result.loginInfo.notifyFollow == 'Y';
										$ionicHistory.nextViewOptions({
											historyRoot: true,
											disableBack: true
										});
										$navigate.go('/', 'slide');
									});

								}else{
									if(r.error || !r.result) console.log('call login Error '+JSON.stringify(r.error));
									var msg = '';
									if (r.error) {
										msg = ' (' + JSON.stringify(r.error) + ')';
									}
                                    navigator.notification.alert(
                                        $scope.msg.msg_login_error + msg,   // message
                                        alertDismissed,                     // callback
                                        $scope.msg.lbl_alert,               // title
                                        $scope.msg.lbl_alert_ok             // buttonName
                                    );
//                                    alert('login error!');
								}
							});
					// });

				});
			}
			,function(){
                navigator.notification.alert(
                    $scope.msg.lbl_alert_login_facebook_error,   // message
                    alertDismissed,                     // callback
                    $scope.msg.lbl_alert,               // title
                    $scope.msg.lbl_alert_ok             // buttonName
                );
//				alert("cannot login facebook!");
			});
		}else{
			confirmLogout();
		}
	};
    function alertDismissed() {
        // do something
    }
	$scope.loginNormal = function(){
		if(!userSessionService.isLogin()){
			var encPassword = utilService.encodePassword($scope.loginForm.password);
			var encUserName = utilService.encodePassword($scope.loginForm.username);
//            console.log('user name enc:'+encUserName);
			var loginData = {
//                username : $scope.loginForm.username
                username : encUserName
                ,password : encPassword
                ,language : $scope.i18n.language.locale
//                ,platform : userSessionService.regisInfo.platform
			};

			//push message
			loginData = pushMessageService.setRegIdToJSON(loginData);
			console.log(JSON.stringify(loginData));

			$ionicLoading.show();
			userSessionService.login(loginData
					, function(r){
						$ionicLoading.hide();
						if(r.error || !r.result) {
							console.log(r);
                            if(r.error=='This user is not Exist.'){
                                navigator.notification.alert(
                                    $scope.msg.msg_no_user,   // message
                                    alertDismissed,                     // callback
                                    $scope.msg.lbl_alert,               // title
                                    $scope.msg.lbl_alert_ok             // buttonName
                                );
//                                alert($scope.msg.msg_no_user);
                            }else{
                                navigator.notification.alert(
                                    $scope.msg.msg_user_expire,   // message
                                    alertDismissed,                     // callback
                                    $scope.msg.lbl_alert,               // title
                                    $scope.msg.lbl_alert_ok             // buttonName
                                );
//                                alert($scope.msg.msg_user_expire);
                            }
                        }else if(r.result && r.result.loginInfo){
//							console.log("login complete.");
                            console.log('login:'+JSON.stringify(r.result.loginInfo));
							userSessionService.setUserSession(
                                utilService.decodePassword(r.result.loginInfo.username),
                                r.result.loginInfo.userId,
                                false,
                                r.result.loginInfo.notifyComment,
                                r.result.loginInfo.notifyFollow,
                                r.result.loginInfo.userRef,
                                r.result.loginInfo.isPostLensAdmin);

								$ionicHistory.nextViewOptions({
									historyRoot: true,
									disableBack: true
								});
								$scope.$applyAsync(function(){
									$scope.toggle.checkComment = r.result.loginInfo.notifyComment == 'Y';
									$scope.toggle.checkFollow = r.result.loginInfo.notifyFollow == 'Y';
									$navigate.go('/', 'slide');
								});
						}else{
							var msg = '';
							if (r.error) {
								msg = ' (' + r.error.code + ': ' + r.error.message + ')';
							}
                            navigator.notification.alert(
                                $scope.msg.msg_login_error + msg,   // message
                                alertDismissed,                     // callback
                                $scope.msg.lbl_alert,               // title
                                $scope.msg.lbl_alert_ok             // buttonName
                            );
//                            alert($scope.msg.msg_login_error);
						}
					});

		}else{
			confirmLogout();
		}
	};

	function confirmLogout(){
		//alert("1111111")

		//navigator.notification.confirm('Already Loggedin, Confirm Logout?', function(index) {
		navigator.notification.confirm($scope.msg.popup_confirm_logout+','+$scope.msg.popup_logout, function(index) {
		
			if (index == 1) {

				if(userSessionService.isUserFacebook){
					//logout facebook
                    facebook.logout();
				}
				//logout
				userSessionService.clearUserSession();

				$ionicHistory.nextViewOptions({
					historyRoot: true,
					disableBack: true
				});
                $scope.$applyAsync(function(){
					$navigate.go('/', 'slide');
				});
			}
		}, $scope.msg.popup_text_logout, $scope.msg.btn_ok+','+$scope.msg.btn_cancel);
	}
	$scope.$on('$ionicView.enter', function() {
				$rootScope.$broadcast('updateNavBar',{showFB:false,searchshop:false,map_all:false,showAR:false});
	})
});
