postLensApp.controller('MapAllCtrl', function(
                                        $scope, $timeout, selected_searchMode_DataModel,
                                        geolocation, shopInfoService, provinceService, $navigate) {

//    $window, userSessionService,
//        $navigate, selected_shop_DataModel

	if (!window.google) {
		navigator.notification.alert('Google service is not available!!');
		$navigate.back();
	}

	$scope.myMarkers = [];

    //For Search
    $scope.selectedProvince = '';
    $scope.selectedPriceRank = '';
    $scope.searchCriteria = {};
    $scope.searchKeyword = '';
    $scope.shopPostcode='';

    $scope.displayPullUp = 'none';
    $scope.disPlayClass = 'flip';
    $scope.cursorIndex = 0;

	$scope.mapOptions = {
		zoom:16,
	    mapTypeId: google.maps.MapTypeId.ROADMAP,
	    streetViewControl: false,
	    center: new google.maps.LatLng(13.885954, 100.574105)
	};

	$scope.openMarkerInfo = function(marker, index) {
		  $scope.currentMarker = marker;
		  $scope.currentMarkerLat = marker.getPosition().lat();
		  $scope.currentMarkerLng = marker.getPosition().lng();
		  $scope.currentMarkerPlaceName = $scope.shopInfos[index].placeName;
		  $scope.currentMarkerPlaceNameEng = $scope.shopInfos[index].placeNameEng;
		  $scope.currentMarkerBranchAddr = $scope.shopInfos[index].branchAddr;
		  $scope.currentMarkerBranchAddrEng = $scope.shopInfos[index].branchAddrEng;
		  $scope.currentMarkerTels = $scope.shopInfos[index].tels;

		  $scope.myInfoWindow.open($scope.allMap, marker);
	};


    //List Full Province
    //List Full Province
    provinceService.getAllProvince(function (r) {
        if (r.error || !r.result) console.log('call getAllProvince Error');
        else if (r.result) {
            //console.log('result: ' + JSON.stringify(r.result));
            $scope.provinces = r.result.allProvinces;

            //List Price Rank
            shopInfoService.getAllPriceRank(function (r) {
                if (r.error || !r.result) console.log('call getAllPriceRank Error');
                else if (r.result) {
//                    console.log('result: ' + JSON.stringify(r.result));
                    $scope.priceRanks = r.result.allPriceRank;


                    //List Full Popular Service
                    shopInfoService.getAllPostService(function (r) {
                        if (r.error || !r.result) console.log('call getAllPostService Error');
                        else if (r.result) {
//            console.log('result: ' + JSON.stringify(r.result));
                            $scope.branchServices = r.result.allPostServices;
                        }
                    });

                }
            });
        }
    });
//
//    provinceService.getAllProvince(function(r){
//        if(r.error || !r.result) console.log('call getAllProvince Error');
//        else if(r.result){
//            $scope.provinces = r.result.allProvinces;
//        }
//    });

    //Display Filter By Post or Shop
    $scope.filterShop = "none";
    $scope.filterPost = "block";
    $scope.filterLabel = "ที่ทำการไปรษณีย์";
    $scope.toSwitch = function () {
        if ($scope.filterPost == "none") {
            $scope.filterShop = "none";
            $scope.filterPost = "block";
            $scope.filterLabel = "ที่ทำการไปรษณีย์";
        } else {
            $scope.filterShop = "block";
            $scope.filterPost = "none";
            $scope.filterLabel = "ร้านค้าที่ร่วมรายการ";
        }
    }

    $scope.changeSearchMode = function(mode, modeTxt){
        $scope.curSearchMode = modeTxt;
        selected_searchMode_DataModel.setSearchMode(mode);
        startSearch();
    }

    $scope.checkbox_filter_type = { "popular":false, "hightrate":false, "recently":false }

    $scope.checkbox_filter_other = { "park":false, "beer":false, "credit":false }

    $scope.checkbox_filter_service = {
        "s001":false,
        "s002":false,
        "s003":false,
        "s004":false,
        "s005":false,
        "s006":false,
        "s007":false,
        "s008":false,
        "s009":false,
        "s010":false,
        "s011":false,
        "s012":false
    }
    $scope.checkbox_filter_post = {"park":false}

    $scope.radio_filter_price='';

    $scope.selectPrice = function(price){
//        console.log('select price...');
        $scope.selectedPriceRank = price.prId;
    }

    $scope.doFilter = function(){
//        console.log('xxxxxxxx');
        try{
            var tmpFilterOption = {};
            if ($scope.filterPost == "none") {
//                console.log('create condition: shopType : S ');
                tmpFilterOption["shopType"] = "S";

                if($scope.checkbox_filter_other.park){
//                    console.log('create condition: parking : '+$scope.checkbox_filter_other.park);
                    tmpFilterOption["parking"] = 'Y';
                }
                if($scope.checkbox_filter_other.beer){
//                    console.log('create condition: beer : '+$scope.checkbox_filter_other.beer);
                    tmpFilterOption["beer"] = 'Y';
                }
                if($scope.checkbox_filter_other.park){
//                    console.log('create condition: credit : '+$scope.checkbox_filter_other.credit);
                    tmpFilterOption["credit"] = 'Y';
                }

                if($scope.checkbox_filter_type.popular){
//                    console.log('create condition: popular : '+$scope.checkbox_filter_type.popular);
                    tmpFilterOption["popular"] = 'Y';
                }
                if($scope.checkbox_filter_type.hightrate){
//                    console.log('create condition: hightrate : '+$scope.checkbox_filter_type.hightrate);
                    tmpFilterOption["hightrate"] = 'Y';
                }
                if($scope.checkbox_filter_type.recently){
//                    console.log('create condition: recently : '+$scope.checkbox_filter_type.recently);
                    tmpFilterOption["recently"] = 'Y';
                }

                if($scope.selectedPriceRank!=''){
//                    console.log('create condition: priceRankId : '+$scope.selectedPriceRank);
                    tmpFilterOption["priceRankId"] = $scope.selectedPriceRank;
                }

                //        if(){
                //            tmpFilterOption["shopBusiness"] = '';
                //        }
            }else{
//                console.log('create condition: shopType : "P" , "B" ');
                tmpFilterOption["shopType"] = 'P,B';

                if($scope.checkbox_filter_post.park){
//                    console.log('create condition: Post parking : '+$scope.checkbox_filter_post.park);
                    tmpFilterOption["parking"] = 'Y';
                }

                if(document.getElementById("txtPostCodefilter").value!=''){
                    console.log('create condition: postCode : '+document.getElementById("txtPostCodefilter").value);
                    tmpFilterOption["postCode"] = document.getElementById("txtPostCodefilter").value;
                }
                //Service
                if($scope.checkbox_filter_service.s001 ||
                    $scope.checkbox_filter_service.s002 ||
                    $scope.checkbox_filter_service.s003 ||
                    $scope.checkbox_filter_service.s004 ||
                    $scope.checkbox_filter_service.s005 ||
                    $scope.checkbox_filter_service.s006 ||
                    $scope.checkbox_filter_service.s007 ||
                    $scope.checkbox_filter_service.s008 ||
                    $scope.checkbox_filter_service.s009 ||
                    $scope.checkbox_filter_service.s010 ||
                    $scope.checkbox_filter_service.s011 ||
                    $scope.checkbox_filter_service.s012){
                    var serviceFilter = '';
                    var concat = '';
                    if($scope.checkbox_filter_service.s001){ serviceFilter += concat+'\'S001\'';concat=','}
                    if($scope.checkbox_filter_service.s002){ serviceFilter += concat+'\'S002\'';concat=','}
                    if($scope.checkbox_filter_service.s003){ serviceFilter += concat+'\'S003\'';concat=','}
                    if($scope.checkbox_filter_service.s004){ serviceFilter += concat+'\'S004\'';concat=','}
                    if($scope.checkbox_filter_service.s005){ serviceFilter += concat+'\'S005\'';concat=','}
                    if($scope.checkbox_filter_service.s006){ serviceFilter += concat+'\'S006\'';concat=','}
                    if($scope.checkbox_filter_service.s007){ serviceFilter += concat+'\'S007\'';concat=','}
                    if($scope.checkbox_filter_service.s008){ serviceFilter += concat+'\'S008\'';concat=','}
                    if($scope.checkbox_filter_service.s009){ serviceFilter += concat+'\'S009\'';concat=','}
                    if($scope.checkbox_filter_service.s010){ serviceFilter += concat+'\'S010\'';concat=','}
                    if($scope.checkbox_filter_service.s011){ serviceFilter += concat+'\'S011\'';concat=','}
                    if($scope.checkbox_filter_service.s012){ serviceFilter += concat+'\'S012\'';concat=','}
                    if(serviceFilter!=''){
                        tmpFilterOption["postService"] = serviceFilter;
                    }
                }
            }
            $scope.searchCriteria = tmpFilterOption;
        }catch(err){
            console.log('Error:'+err);
        }
        $scope.changeSearchMode('S','Filter');
    }

    $scope.selectProvice = function(province){
        if(province){
//            console.log("province:" + province.description);
            $scope.$applyAsync(function () {
                $scope.selectedProvince = province;
                $scope.resultList = null;
                $scope.displayPullUp = 'none';
                $scope.cursorIndex = 0;
            });
        }else{
            $scope.$applyAsync(function () {
                $scope.selectedProvince = '';
                $scope.resultList = null;
                $scope.displayPullUp = 'none';
                $scope.cursorIndex = 0;
            });
        }
    }

    //----on load----
	function startSearch(){
	if(selected_searchMode_DataModel.selectedSearchMode.mode == 'N'){
		geolocation.getCurrentPositionOnload(function (position) {
//		    console.log('Latitude: '              + position.coords.latitude          + '\n' +
//		          'Longitude: '             + position.coords.longitude         + '\n' +
//		          'Altitude: '              + position.coords.altitude          + '\n' +
//		          'Accuracy: '              + position.coords.accuracy          + '\n' +
//		          'Altitude Accuracy: '     + position.coords.altitudeAccuracy  + '\n' +
//		          'Heading: '               + position.coords.heading           + '\n' +
//		          'Speed: '                 + position.coords.speed             + '\n' +
//		          'Timestamp: '             + position.timestamp                + '\n');

		    $scope.allMap.setCenter(new google.maps.LatLng(position.coords.latitude, position.coords.longitude));
		    //set markers
		    geolocation.clearMap();
		    geolocation.setMarkers([]);

//            var icon = 'images/icons/mapsignblue.png';
//            geolocation.makeMarker(
//                new google.maps.LatLng(position.coords.latitude,
//                                        position.coords.longitude)
//                , $scope.allMap
//                , icon);

		    selected_searchMode_DataModel.selectedSearchMode.geolocation.lat = position.coords.latitude;
		    selected_searchMode_DataModel.selectedSearchMode.geolocation.lng = position.coords.longitude;

		    shopInfoService.searchShop(selected_searchMode_DataModel.selectedSearchMode
		    		,function(r){
			    		if(r.error || !r.result) console.log('call searchShop Error');
						else if(r.result){
							showSearchMarker(r.result.shopResults);
						}
			    	});


		  }, function(){
			  navigator.notification.alert($scope.msg.call_geolocation_error);

			//set markers
			    geolocation.clearMap();
			    geolocation.setMarkers([]);

			    selected_searchMode_DataModel.setSearchMode('P');

			    shopInfoService.searchShop(selected_searchMode_DataModel.selectedSearchMode
			    		,function(r){
				    		if(r.error || !r.result) console.log('call searchShop Error');
							else if(r.result){
								showSearchMarker(r.result.shopResults);
							}
				    	});
		  });
	}else if (selected_searchMode_DataModel.selectedSearchMode.mode == 'B'){
        shopInfoService.searchShop(
            selected_searchMode_DataModel.selectedSearchMode
            ,function(r){
                if(r.error || !r.result){console.log('call searchShop Error:mode B');}
                else if(r.result){showSearchMarker(r.result.shopResults);}
        });
    }else if (selected_searchMode_DataModel.selectedSearchMode.mode == 'L'){
//        console.log('Search mode : L, provinceCode:'+$scope.selectedProvince.value);
        selected_searchMode_DataModel.selectedSearchMode.provinceCode = $scope.selectedProvince.value;
        shopInfoService.searchShop(
            selected_searchMode_DataModel.selectedSearchMode
            ,function(r){
                if(r.error || !r.result){console.log('call searchShop Error:mode L');}
                else if(r.result){showSearchMarker(r.result.shopResults);}
            });
    }else if (selected_searchMode_DataModel.selectedSearchMode.mode == 'S'){
        if($scope.selectedProvince!=''){
            selected_searchMode_DataModel.selectedSearchMode.provinceCode = $scope.selectedProvince.value;
        }
        if($scope.searchKeyword!=''){
            selected_searchMode_DataModel.selectedSearchMode.keyword = $scope.searchKeyword;
        }
        selected_searchMode_DataModel.selectedSearchMode.filterOption = $scope.searchCriteria;
    }else{
		//set markers
		$scope.onMapReady = function(){
//	    	console.log("map ready..");

	    	geolocation.clearMap();
		    geolocation.setMarkers([]);
		    shopInfoService.searchShop(selected_searchMode_DataModel.selectedSearchMode
		    		,function(r){
			    		if(r.error || !r.result) console.log('call searchShop Error');
						else if(r.result){
							showSearchMarker(r.result.shopResults);
						}
			    	});
	    };
	}
    }



	function showSearchMarker(markersPosition){
//		console.log("position: "+JSON.stringify(markersPosition));
		if(markersPosition.length <= 0){
	    	alert("nearby Shop/Branch not found.");
	    }

//        console.log("nearby Shop/Branch found:"+markersPosition.length);
	    $scope.shopInfos = markersPosition;

	    for(var i = 0; i < markersPosition.length; ++i){
	    	if(selected_searchMode_DataModel.selectedSearchMode.mode != 'N'
	    			&& i == 0){
	    		$scope.allMap.setCenter(new google.maps.LatLng(markersPosition[i].geolocation.lat
	    				, markersPosition[i].geolocation.lng));
	    	}

	    	var icon;
	    	if(markersPosition[i].shopType == 'B'){
	    		icon = 'images/icons/mapsignpink.png';
	    	}else{
	    		icon = 'images/icons/mapsignblue.png';
	    	}

	    	geolocation.makeMarker(
	    			        new google.maps.LatLng(markersPosition[i].geolocation.lat,
	    					               markersPosition[i].geolocation.lng)
	    					, $scope.allMap
	    					, icon);
	    }
	    $scope.$applyAsync(function(){
//            console.log("create marker:"+geolocation.getMarkers().length);
            $scope.myMarkers = geolocation.getMarkers();
        });

	}

    selected_searchMode_DataModel.setSearchMode("N");
    startSearch();
});
