'use strict';
postLensApp.controller('profileCtrl', function($scope, $navigate, userProfile_DataModel,
                                               userSessionService, userProfileService, captureService) {
    function onSuccess(imageData) {
        $scope.$applyAsync(function(){
        	$scope.userProfile.userImage = imageData;
            $scope.userProfile.userImageUrl = "data:image/jpeg;base64,"+imageData;
        });
    }

    function onFail(message) {
        //navigator.notification.alert('Failed because: ' + message);
    }
    
    function showUserProfile(){
        //userSessionService.userId = 23110 //19257 //510
    	var userData = {userId : userSessionService.userId};
    	
        $scope.setLoading(true);
    	userProfileService.getUserProfile(userData, function(r){
            $scope.setLoading(false);
			if(r.error || !r.result) console.log('call getUserProfile Error');
			else if(r.result){
				var profile = r.result.userProfile;
                //date//
                if (typeof profile.birthDate == 'string') {
                    profile.birthDate = new Date(profile.birthDate);
                }
				userProfile_DataModel.userProfile = profile;
				$scope.$applyAsync(function(){
					$scope.userProfile = userProfile_DataModel.userProfile;
				});
			}
		});
    }

    $scope.changeProfileImage = function(){
        captureService.cameraCapture(onSuccess
            ,onFail
            ,{ quality: 40
                ,encodingType: Camera.EncodingType.JPEG
                ,destinationType : Camera.DestinationType.DATA_URL
                ,targetWidth: 100
                ,targetHeight: 100 });
    }

    $scope.saveProfile = function(){
        console.log('saveProfile start...['+$scope.userProfile.address+']');
        if($scope.userProfile.address==""){
            navigator.notification.alert($scope.msg.msg_validate_address);
        }else if($scope.userProfile.email==""){
            navigator.notification.alert($scope.msg.msg_validate_email);
//        }else if($scope.userProfile.personalId==""){
//            navigator.notification.alert($scope.msg.msg_validate_pin);
        }else if($scope.userProfile.birthDate==""){
            navigator.notification.alert($scope.msg.msg_validate_birthDate);
        }else if($scope.userProfile.firstName==""){
            navigator.notification.alert($scope.msg.msg_validate_firstName);
        }else if($scope.userProfile.lastName==""){
            navigator.notification.alert($scope.msg.msg_validate_lastName);
        }else{
            $scope.setLoading(true);
            userProfileService.saveProfile($scope.userProfile, function(r){
                $scope.setLoading(false);
                if(r.error || !r.result) console.log('call getUserProfile Error');
                else if(r.result && r.result.saveResult == "ok"){
                    console.log("saveProfile complete.");
                    navigator.notification.alert($scope.msg.msg_success_profile);
                    showUserProfile();
                }else{
                    alert('saveProfile error!');
                }
            });
        }
    }
    
    //loaded
    $scope.$on('$ionicView.enter',function() {
    	if(userSessionService.isLogin()){
    		showUserProfile();
    	}else if(!$scope.userProfile){
    		// baseCtrl
    		$scope.confirmLogin(true);
    	}
    });
	
	
});