'use strict';
postLensApp.controller('promotionCtrl', function ($scope, selected_shop_DataModel,
                                                  shopInfoService, facebook, $stateParams, $ionicSlideBoxDelegate) {

    if ($stateParams.id) {
        $scope.updateShop($stateParams.id);
    }
    
    $scope.pageName = 'โปรโมชั่น';
    $scope.placeName = '';
    $scope.showWriter = false;
    $scope.score = 5;

    $scope.slidebox = {currentSlide: 0, currentRate: 5};

    $scope.slideChanged = function(index) {
        //$scope.slidebox.currentRate = $scope.getCurrentSlide().score;
    }

    $scope.getCurrentSlide = function() {
        return ($scope.imageList || {})[$scope.slidebox.currentSlide];
    }

    $scope.clickVote = function(){
        $scope.showWriter = !$scope.showWriter;
    }
    function alertDismissed() {
        // do something
    }
    $scope.vote = function(){
        if (!$scope.getCurrentSlide().promoId) {
            console.warn('dummy promo');
            return;
        }
        shopInfoService.vote(
            {voteId:$scope.getCurrentSlide().promoId, score:$scope.score, method:'votePromotion'},
            function(r){
                if(r.requireLogin) {
                    $scope.confirmLogin(false);
                }
				else if(r.error || !r.result) {
                    console.log('call votePromotion Error');
                    if (r.error == 'already_vote') {
                        navigator.notification.alert($scope.msg.lbl_alert_already_vote);
                    }
                }
                else if(r.result){
                    navigator.notification.alert(
                        $scope.msg.msg_save_ok,         // message
                        alertDismissed,                 // callback
                        $scope.msg.msg_title_alert,     // title
                        $scope.msg.lbl_alert_ok         // buttonName
                    );
                    $scope.$applyAsync(function(){
                        if(r.result.data[0].score){
                            $scope.getCurrentSlide().score = roundNumber(r.result.data[0].score,0);
                            $scope.slidebox.currentRate = roundNumber(r.result.data[0].score,0);
                            $scope.showWriter = !$scope.showWriter;
                        }
                    });
                }
            });
    }

    $scope.getCurImageName = function () {
        return $scope.getCurrentSlide().promoName;
    }

    ///ionic
    var fbwatch;
    $scope.$on('$ionicView.leave', function() {
        fbwatch();
    })
    $scope.$on('$ionicView.enter', function() {
        fbwatch = $scope.$on('sharefb', function(){
            $scope.facebookSharePromotion();
        })
    })
    $scope.facebookSharePromotion = function(){
        console.log("do FB share Promotion ...");
        facebook.share($scope.shopInfo.placeName
            , 'http://www.thailandpost.co.th/'
            , $scope.getCurrentSlide().promoImage
            , $scope.shopInfo.addr
            , '');
    }

    console.log('searchImagePromotion: id:'+$stateParams.id);
    var arg = null
    if($stateParams.id != ''){
    	arg = {shopId: $stateParams.id}
    }

    function roundNumber(rnum, rlength) {
        var newnumber = Math.round(rnum * Math.pow(10, rlength)) / Math.pow(10, rlength);
        return newnumber;
    }

    shopInfoService.searchPromotion(arg
    	,function(r){
			if(r.error || !r.result) console.log('call searchPromotion Error');
			else if(r.result){
                $scope.$applyAsync(function(){
                    $scope.imageList = r.result.promotions;
                    $ionicSlideBoxDelegate.update();
                })
			}
		});
    


});