'use strict';
postLensApp.controller('registerCtrl', function ($scope,$navigate,$window,$ionicHistory,
                                                 userSessionService,
                                                 soapService,
                                                 pushMessageService,
                                                 utilService) {
    $scope.listHeight = ($window.innerHeight - 40) + 'px';

    $scope.notBlackListed = function(value) {
        var blacklist = ['bad@domain.com','verybad@domain.com'];
        return blacklist.indexOf(value) === -1;
    }

    $scope.formData = {};
    $scope.formData.password="";
    $scope.formData.confirm_password="";
    $scope.formData.birth_date="";
    $scope.formData.email="";
    $scope.formData.firstname="";
    $scope.formData.lastname="";
    $scope.formData.confirmCode="";
    
    $scope.isRegistering = false;

    $scope.$on('notification', function(e, data){
        console.info(e, data);
        if (data.additionalData) {
            alert(data.additionalData.msg);
            if (data.additionalData.msg.search('verification code is') >= 0) {
                $scope.formData.confirmCode = data.additionalData.msg.split(' ')[3];
                $scope.$applyAsync();
            }
        }
    });


    $scope.wsGetCusByEmail = function(){
        soapService.wsGetCusByEmail(
            {email: 'chang787@yahoo.com'}
            ,function(GetCusByEmailResult){
                console.log('result:'+JSON.stringify(GetCusByEmailResult));
            });
    }
    $scope.wsInsertNewCus = function(){
        soapService.wsInsertNewCus(
            {
                firstName:'chang',
                lastName:'chang787',
                email:'chang787x@yahoo.com',
                password:'xxxxx',
                birth_date:'2556-06-06'
            }
            ,function(InsertNewCusResult){
                console.log('result:'+JSON.stringify(InsertNewCusResult));
            });
    }

    $scope.register = function(){
        try{
            var encPassword = utilService.encodePassword($scope.formData.password);

            var registerData = {
                    firstName : $scope.formData.firstname
                    ,lastName : $scope.formData.lastname
                    ,email : $scope.formData.email
                    ,password : encPassword
                    ,language : $scope.i18n.language.locale
                    ,birth_date : $scope.formData.birth_date
            };

            //push message : add [regId]
            registerData = pushMessageService.setRegIdToJSON(registerData);

            userSessionService.register(registerData, function(r){
                console.log('register result:'+JSON.stringify(r));
					if(r.error || !r.result){
                        navigator.notification.alert(
                            $scope.msg.msg_error,
                            function(){
                                console.log('call register Error');
                            },
                            $scope.msg.msg_title_alert,
                            $scope.msg.btn_ok
                        );
					}
					else if(r.result && r.result.saveResult == 'ok'){
                        if(r.result.status=='R'){
                            console.log("register complete. get Validate Code");
                            $scope.$applyAsync(function(){
                                $scope.isRegistering = false;//call save customer info OK change true -> false
                                $scope.listHeight = ($window.innerHeight + 60) + 'px';
                                userSessionService.setRegisInfo(registerData);
                            });
                        }else{
                            navigator.notification.alert(
                                $scope.msg.msg_already_register_login
                                , function() {
                                    $scope.$applyAsync(function(){
                                        $navigate.go('/login_form', 'fade');
                                    });
                                }
                                , $scope.msg.msg_title_alert
                                , $scope.msg.lbl_login);
                        }
						
					}else{
						alert('register error!');
					}
				});
        }catch(err){
            alert('Error:'+err);
        }
	};
	
	$scope.getNewValidateCode = function(){
		userSessionService.getNewValidateCode({email : $scope.formData.email}
				, function(r){
					if(r.error || !r.result){
                        navigator.notification.alert(
                            $scope.msg.msg_new_verifly_error+':'+r.error,
                            function(){
                                console.log('call getNewValidateCode Error');
                            },
                            $scope.msg.msg_title_alert,
                            $scope.msg.btn_ok
                        );
					}
					else if(r.result && r.result.saveResult == 'ok'){
                        navigator.notification.alert(
                            $scope.msg.msg_new_verifly_ok,
                            function(){
                                console.log("call complete. get Validate Code");
                            },
                            $scope.msg.msg_title_alert,
                            $scope.msg.btn_ok
                        );
					}else{
                        navigator.notification.alert(
                            $scope.msg.msg_new_verifly_error,
                            function(){
                                console.log('getNewValidateCode error!');
                            },
                            $scope.msg.msg_title_alert,
                            $scope.msg.btn_ok
                        );
					}
				});
	};
	
	$scope.confirmRegister = function(){
		
		var confirmData = {
				email : $scope.formData.email
				,confirmCode : $scope.formData.confirmCode
		};
		
		
		userSessionService.registerConfirm(confirmData, function(r){
					if(r.error || !r.result){
						console.log('call confirmRegister Error');
						if(r.error == 'external_fail'){
							navigator.notification.alert(window.lang.convert(
									'Registeration Uncomplete, please contect Call Center.')
								, function() {
									$scope.$applyAsync(function(){
										$navigate.go('/', 'slide');
									});
								}, window.lang.convert('Message')
								, window.lang.convert('Ok'));
						}else{
							alert(r.error);
						}
					}
					else if(r.result && r.result.saveResult == 'ok'){
						console.log("register all complete");
						userSessionService.clearRegisInfo();
						$ionicHistory.nextViewOptions({
							historyRoot: true,
							disableBack: true
						});
                        $scope.$applyAsync(function(){
                            $navigate.go('/', 'slide');
                        });
//						navigator.notification.alert(
//                                window.lang.convert('Registeration Complete')
//								, function() {
//                                    console.log("Start clearRegisInfo...");
//									userSessionService.clearRegisInfo();
//									$scope.$applyAsync(function(){
//										$navigate.go('/', 'slide');
//									});}
//                                , window.lang.convert('Message')
//								, window.lang.convert('Ok'));
						
					}else{
						alert('register error!');
					}
				});
	};
	
$scope.cancelRegister = function(){
		
		var cancelData = {
				email : $scope.formData.email
		};
		
		
		userSessionService.registerCancel(cancelData, function(r){
					if(r.error || !r.result){
						console.log('call cancelRegister Error');
						alert(r.error);
					}
					else if(r.result && r.result.saveResult == 'ok'){
						console.log("cancel complete");
                        userSessionService.clearRegisInfo();
                        $scope.$applyAsync(function(){
                            $navigate.go('/', 'slide');
                        });
						
					}else{
						alert('register error!');
					}
				});
	};
	
	//onload
	if(userSessionService.regisInfo){
		console.log("onload : map regisInfo");
		$scope.formData.password = userSessionService.regisInfo.password;
	    $scope.formData.confirm_password = userSessionService.regisInfo.password;
	    $scope.formData.email = userSessionService.regisInfo.email;
	    $scope.formData.firstname = userSessionService.regisInfo.firstName;
	    $scope.formData.lastname = userSessionService.regisInfo.firstName;
	}

    $scope.isRegistering = userSessionService.isStepRegister;//true;
});