'use strict';
postLensApp.controller('searchCtrl', function ($scope, $navigate,
                                               provinceService, shopInfoService,
                                               $window, userSessionService,
                                               geolocation, cordovaReady,
                                               $q, $ionicModal, $ionicScrollDelegate, uiGmapGoogleMapApi,
                                               $ionicHistory,$timeout,$ionicLoading) {
    var defaultFilter = {branch:true, shop:false, post:{}};
    $scope.filterValue = angular.copy(defaultFilter);
    $scope.selected = {};
    $scope.limitTo = 20;

    var stateName = $ionicHistory.currentStateName();
    $scope.showMap = false;
    if (stateName.search("map") >= 0) {
        $scope.showMap = true;
    }

    var boot = function(sconnected) {
        console.log('boot start:'+sconnected);
        $scope.changeSearchMode('N');

        async.parallel([
            function (next) {
                provinceService.getAllProvince(function (r) {
                    if (r.error || !r.result) console.log('call getAllProvince Error');
                    else if (r.result) {
                        $scope.provinces = r.result.allProvinces;
                        console.log('province success', $scope.provinces);
                    }
                    next(r.error);
                });
            },
    //         function (next) {
    //             shopInfoService.getAllPriceRank(function (r) {
    //                 if (r.error || !r.result) console.log('call getAllPriceRank Error');
    //                 else if (r.result) {
    // //                    console.log('result: ' + JSON.stringify(r.result));
    //                     $scope.priceRanks = r.result.allPriceRank;
    //                 }
    //                 next(r.error);
    //             });
    //         },
            function (next) {
                shopInfoService.getAllPostService(function (r) {
                    if (r.error || !r.result) console.log('call getAllPostService Error');
                    else if (r.result) {
                        $scope.branchServices = r.result.allPostServices;
                    }
                    next(r.error);
                });
            }, function (next) {
                shopInfoService.getDropdownShopType(function(sResult){
                    if(sResult.error || !sResult.result){
                        console.log('call getDropdownSType Error');
                    }else{
                        $scope.$applyAsync(function() {
                            $scope.lov_stype = sResult.result.sTypeResults;
                            console.log($scope.lov_stype);
                            $scope.lov_stype.forEach(function (type){
                                if ($scope.checkEnglishLanguage) {
                                    type.desc = type.descriptionEng;
                                } else {
                                    type.desc = type.description;
                                }
                            })
                        });
                    }
                });
            }
        ], function(err){
            console.log(err, "FIN");
            $scope.$applyAsync();
            if(err) alert('error init');
            if(!$scope.curMode) {
                $timeout(function(){$scope.changeSearchMode('N');},500);
            }
        })
    };

    $scope.$on('language-switch', function(obj, val){
        if ($scope.lov_stype) {
            console.log('switch', val);
            $scope.lov_stype.forEach(function (type) {
                if (val == 'th') type.desc = type.description;
                else if (val == 'en') type.desc = type.descriptionEng || type.description;
            })
        }
    })

    $scope.removeBookmark = function(shop,index){

        shopInfoService.removeBookmark(
            {
                userId:userSessionService.userId,
                locationId:shop.shopId
            }
            ,function(r){
                if(r.result.deleteResult){
                    $scope.$applyAsync(function(){
                        if(index<$scope.resultList.length){
                            $scope.resultList[index].active = false;
                            $scope.resultList.splice(index,1);
                        }
                    });
//                    console.log('delete successfully');
//                    alert(r.result.deleteResult);
                    if (r.result.deleteResult && r.result.deleteResult=='ok') {
//                        console.log('delete successfully');
                        navigator.notification.alert(
                            $scope.msg.msg_delete_ok,
                            function(){},
                            $scope.msg.msg_title_alert,
                            $scope.msg.btn_ok
                        )
                    }else{
//                        console.log('delete unsuccessfully');
                        navigator.notification.alert(
                            $scope.msg.msg_delete_fail,
                            function(){},
                            $scope.msg.msg_title_alert,
                            $scope.msg.btn_ok
                        )
                    }
                }
            });
    }

    var openModal = function(title, value) {
        return $q(function(resolve, reject){
            var _modal = null;
            console.log(angular.copy($scope.filterValue));
            $ionicModal.fromTemplateUrl('modals/searchmodal.html', {
                scope: $scope
            }).then(function(modal) {
                _modal = modal;
                angular.extend(_modal.scope, {title:title});
                //internal
                _modal.scope.toggleService = function(i) {
                    _modal.scope.filterValue.post[i] = _modal.scope.filterValue.post[i] ? null : true;
                }
                _modal.scope.search = function(_value) {
                    _modal.hide().then(function(){
                        _modal.remove();
                    });
                    resolve(null);
                }
                _modal.scope.closeModal = function(_value) {
                    _modal.hide().then(function(){
                        _modal.remove();
                    });
                    // resolve(null);
                    //if (_value) resolve(JSON.parse(_value)); else reject(null);
                };
                _modal.show();
            }).catch(function(e){
                console.log('catch1 '+e);
                reject(e);
            });
        });
    };

    $scope.openModal = function(title, value) {
       $scope.curMode="S";$scope.$applyAsync();
        openModal(title, value).then($scope.doFilter);
    }

    var openProvinceModal = function(title, value) {
        console.log('openProvinceModal',title,value);
        return $q(function(resolve, reject){
            var _modal = null;
            $ionicModal.fromTemplateUrl('modals/listselectmodal.html', {
                scope: $scope
            }).then(function(modal) {
                _modal = modal;
                angular.extend(_modal.scope, {out:{value:value}, title:title, isShowNone:true, thKey:'description', enKey:'descriptionEng'});
                //internal
                _modal.scope.loading = true;
                _modal.scope.stringify = function(item) {
                    return JSON.stringify(item);
                }
                _modal.scope.closeModal = function(_value) {
                    _modal.hide().then(function(){
                        _modal.remove();
                    });
                    // resolve(null);
                    // if (_value) resolve(JSON.parse(_value)); else reject(null);
                    // if (_value)
                    console.log('out value',_value);
                    resolve(_value); //else reject(null);
                };
                _modal.show().then(function (arg) {
                    angular.extend(_modal.scope, {thelist:$scope.provinces});
                    _modal.scope.loading = false;
                    _modal.scope.$applyAsync();
                });
            }).catch(function(e){
                console.log('catch1 '+e);
                reject(e);
            });
        });
    }

    $scope.openProvinceModal = function(title) {
        $scope.curMode="L"; $scope.$applyAsync();
        var promise = openProvinceModal(title, $scope.selected.Province);
        if (promise.then) {
            promise.then(function(v){
                $scope.selected.Province = v;
                $scope.changeSearchMode('L');
            });
        }
    }

    // $scope.doFilter = function() {
    //     var tmpFilterOption = {};
    //     if ($scope.filterValue.branch) {
    //         tmpFilterOption["shopType"] = 'P,B';
    //         var fields = ["parking"];
    //         fields.forEach(function(f){
    //             if ($scope.filterValue[f]) tmpFilterOption[f] = "Y";
    //         })
    //         tmpFilterOption["postCode"] = $scope.filterValue.postcode;
    //         var sfields = ["S001", "S002", "S003", "S004", "S005", "S006", "S007", "S008", "S009", "S010", "S011"];
    //         var postServices = [];
    //         if ($scope.filterValue.post) {
    //             sfields.forEach(function(f) {
    //                 if ($scope.filterValue.post[f]) postServices.push(f);
    //             })
    //             if (postServices.length) {
    //                 tmpFilterOption["postService"] = postServices.join(",");
    //             }
    //         }

    //     } else {
    //         tmpFilterOption["shopType"] = "S";
    //         var fields = ["parking", "beer", "credit", "popular", "hightrate", "recently", "priceRankId"];
    //         fields.forEach(function(f){
    //             if ($scope.filterValue[f]) tmpFilterOption[f] = "Y";
    //         })
    //     }
    //     $scope.searchCriteria = tmpFilterOption;
    //     $scope.changeSearchMode('S','Filter');
    // }

    //new simplified version
    $scope.doFilter = function() {
        $scope.searchCriteria = {
            shopType: $scope.filterValue.shopType,
            postCode: $scope.filterValue.postcode,
            parking: $scope.filterValue.parking
        }
        $scope.changeSearchMode('S','Filter');
    }

    $scope.changeSearchMode = function (mode) {
        $scope.curMode = mode;
        $scope.$applyAsync();
        var strJson = {};
        //TODO: LIMIT SEARCH RESULT
        console.log($scope.selected);
        //The page has more than one scrollbar, therefore require $getByHandle, listscroll is value of delegate-handle tag on the ion-scroll
        setTimeout(function(){
            $ionicScrollDelegate.$getByHandle('listscroll').scrollTop();
        }, 200);

        if(mode=="S"){// Location
            strJson["mode"] = 'S';

            if($scope.selected.Province){
                var province = JSON.parse($scope.selected.Province); //use option ng-repeat
                strJson["provinceCode"] = province.value;
            }
            if($scope.filterValue.keyword!=''){
                strJson["keyword"] = $scope.filterValue.keyword;
            }
            strJson["filterOption"] = $scope.searchCriteria;
            listResult(strJson);

        } else if(mode=="L"){// Location
            if (!$scope.selected.Province) return;
            if ($scope.showMap) $ionicLoading.show();
            strJson["mode"] = 'L';

            if($scope.selected.Province){
                var province = JSON.parse($scope.selected.Province); //use option ng-repeat
                strJson["provinceCode"] = province.value;
            }
            listResult(strJson);

        } else if(mode=='B'){
            console.log('clear');
            $scope.resultList = null;
            if(userSessionService.userId){
                strJson["mode"] = 'B';
                strJson["userId"] = userSessionService.userId;
                listResult(strJson);
            }else{
                $scope.confirmLogin(true);
            }
        } else if(mode=="N"){//Near By
            strJson["mode"] = 'N';
            $scope.finishLoad = false;
            $scope.waitgps = true;
            if ($scope.showMap) $ionicLoading.show();

            var strPosition = {};
            geolocation.getCurrentPosition(function (position) {
                $scope.waitgps = false;
                $scope.position = position;
//                console.log("Search By Postion: ["+position.coords.latitude+","+position.coords.longitude+"]");
                var nearByCriteria = {};
                nearByCriteria["mode"] = 'N';
                strPosition["lat"] = position.coords.latitude; //13.722606//
                strPosition["lng"] = position.coords.longitude; //100.525969//
                nearByCriteria["geolocation"] = strPosition;
                listResult(nearByCriteria);


            }, function(){
                $scope.waitgps = false;
                if ($scope.showMap) $ionicLoading.hide();
                navigator.notification.alert($scope.msg.call_geolocation_error);
                console.log("Geolocation Error!");
            },{ timeout: 10000 });
        }
    }

    var listResult = function(searchCriteria) {
        $scope.loading = true;
        $scope.finishLoad = false;
        var fn = $scope.showMap ? showResultMap : showResultList;
        shopInfoService.searchShop(searchCriteria, fn);
    }

    var showResultList = function (r) {
        $scope.loading = false;
        $scope.finishLoad = true;//mb
        if (r.error || !r.result){
            $scope.$applyAsync(function () {
                $scope.resultList = null;
                $scope.displayPullUp = 'none';
                $scope.cursorIndex = 0;
            });
            console.log('call changeSearchMode.searchShop Error ' + JSON.stringify(r.error));
        }
        else if (r.result) {
            console.log('changeSearchMode result: ')// + JSON.stringify(r.result));

            $scope.$applyAsync(function () {

                //distance ???
                if ($scope.position) {
                    r.result.shopResults.forEach(function(e){
                        if (e.distance || !e.geolocation) return;
                        if (!e.geolocation.lat || !e.geolocation.lng) return;
                        e.distance = geolocation.calculateDistance(
                            $scope.position.coords.latitude, $scope.position.coords.longitude,
                            e.geolocation.lat, e.geolocation.lng
                            )
                    })
                }

                $scope.resultList = r.result.shopResults;
                $scope.cursorIndex = r.result.shopResults.length;

                if(r.result.shopResults.length>=10){
                    $scope.displayPullUp = 'block';
                }else{
                    $scope.displayPullUp = 'none';
                }
                $scope.limitTo = 20;

                //$ionicScrollDelegate.scrollTop();


            });
        }
    }

    $scope.extendLimit = function() {
        // $scope.$applyAsync(function() {
            $scope.limitTo += 20;
        // })
    }

    $scope.mapOptions = {
        streetViewControl: false
    };
    $scope.theMap = {mapReady:false, center:{latitude:13.7, longitude:100.8}, zoom:5, control:{}};
    $scope.infoWindow = {};

    $scope.markerClick = function(shop) {
        console.info(shop);
        if (!$scope.infoWindow.show || ($scope.infoWindow.shop != shop)) {
            $scope.infoWindow.show = true;
            $scope.infoWindow.shop = shop;
            // $scope.infoWindow.coords = {latitude:shop.geolocation.lat, longitude:shop.geolocation.lng};
            $scope.infoWindow.options = {
                position: shop.geolocation,
                pixelOffset: {width:0, height:-40}
            }
        } else {
            $scope.closeClick();
        }
        $scope.$applyAsync();
    }
    $scope.markerClick2 = function(x,y,z) {
        $scope.markerClick(z);
    }
    $scope.closeClick = function() {
        $scope.infoWindow.show = false;
        // $scope.infoWindow.options = {};
    }

    var showResultMap = function (r) {
        $scope.loading = false;
        if (r.error || !r.result){
            console.log('call changeSearchMode.searchShop Error ' + JSON.stringify(r.error));
            if ($scope.showMap) $ionicLoading.hide();
        }
        else if (r.result) {
            console.log('changeSearchMode result: ' + JSON.stringify(r.result));
            var center = r.result.shopResults.reduce(function (pv,cv) {
                if (pv) return pv;
                if (cv.geolocation && cv.geolocation.lat && cv.geolocation.lng) {
                    return cv.geolocation;
                }
                return null;
            }, null);
            console.log(center);
            if ($scope.curMode == "L" && center) {
                $scope.theMap.center.latitude = center.lat;
                $scope.theMap.center.longitude = center.lng;
            } else if ($scope.position) {
                $scope.theMap.center.latitude = $scope.position.coords.latitude;
                $scope.theMap.center.longitude = $scope.position.coords.longitude;
            }
            if ($scope.curMode == "N") {
                $scope.theMap.zoom = 15;
            } else {
                $scope.theMap.zoom = 10;
            }

            if (r.result.shopResults.length == 0) {
                $ionicLoading.hide();
            }

            $scope.$applyAsync(function () {
                $scope.resultList = r.result.shopResults.filter(function(e) {
                    return !!e.geolocation;
                });
                $scope.resultList.forEach(function(m, i){
                    m.geo2 = {latitude:m.geolocation.lat, longitude:m.geolocation.lng};
                    m.options = {};
                    m.options.labelContent = '';
                    m.options.icon = {};
                    if(m.shopType == 'B'){
                        m.options.icon.url = 'images/icons/mapsignpink.png';
                    }else{
                        m.options.icon.url = 'images/icons/mapsignblue.png';
                    }

                    if (i == 0) {
                        setTimeout(function(){ $scope.markerClick(m); }, 500);
                    }
                });

                $scope.theMap.mapReady = true;
                $ionicLoading.hide();
            });
        }
    }

    $scope.getStar = function (index, i) {
        var rating = $scope.resultList[index].branchRating;
        if (i <= rating) return 'images/icons/star_gold_16.png';
        else return 'images/icons/star_white_16.png';
    }

    $scope.alert = function() {
       // alert('555555');
    }
    /*if(!window.sconnected)
    window.connect(boot);
    else boot(window.sconnected);*/
    boot();

    //mb
	/*
    if($scope.thelist.length == 0){
		$scope.thelist.push("No Sessions this Day");
	}
	*/
	$scope.isDayEmpty = function(){
		return $scope.thelist.length > 0 ? false : true;
	}
});
