'use strict';
postLensApp.controller('searchCtrl', function ($scope, $navigate, selected_shop_DataModel,
                                               selected_searchMode_DataModel,
                                               provinceService, shopInfoService,
                                               $window, userSessionService,
                                               geolocation, cordovaReady) {
    $scope.selectedProvince = '';
    $scope.selectedPriceRank = '';
    $scope.searchCriteria = {};
    $scope.searchKeyword = '';
    $scope.shopPostcode='';

    $scope.displayPullUp = 'none';
    $scope.disPlayClass = 'flip';
    $scope.cursorIndex = 0;

    //หาความสูงของพื้นที่ที่จะใช้ iscroll ควรเช็คจาก css ว่าความสูงของแถบ bars ด้านบนเป็น 90px หรือไม่
    $scope.listHeight = ($window.innerHeight - 80) + 'px';
    $scope.listHeightPhone = ($window.innerHeight - 130) + 'px';
    selected_shop_DataModel.reset();

    $scope.navigateTo = function (i, way) {
        selected_shop_DataModel.selectedShop = $scope.resultList[i];

        var target = $scope.toPage(i);
        $navigate.go('/' + target, way);

    }
    $scope.curSearchMode = 'รายการที่อยู่ใกล้';
    $scope.curMode = 'P';
    $scope.searchString = '';
//                       var biztypearray = ['post','postshop', 'shop'],
//                           biztypeiconarray = ['images/testImages/food-icon.png','post','images/iui/PostMascot.png'];


    $scope.toPage = function (index) {
        var targetpage = $scope.resultList[index].shopType == "S" ? 'shop/' : 'branch/';
        return targetpage + $scope.resultList[index].shopId + '/';
    }

    $scope.getStar = function (index, i) {
        var rating = $scope.resultList[index].branchRating;
        if (i <= rating) return 'images/icons/star_gold_16.png';
        else return 'images/icons/star_white_16.png';
    }

    //Display Filter By Post or Shop
    $scope.filterShop = "none";
    $scope.filterPost = "block";
    $scope.filterLabel = "ที่ทำการไปรษณีย์";
    $scope.toSwitch = function () {
        if ($scope.filterPost == "none") {
            $scope.filterShop = "none";
            $scope.filterPost = "block";
            $scope.filterLabel = $scope.msg.lbl_popover_post;
        } else {
            $scope.filterShop = "block";
            $scope.filterPost = "none";
            $scope.filterLabel = $scope.msg.lbl_popover_shop;
        }
    }

    $scope.checkbox_filter_type = { "popular":false, "hightrate":false, "recently":false }

    $scope.checkbox_filter_other = { "park":false, "beer":false, "credit":false }

    $scope.checkbox_filter_service = {
        "s001":false,
        "s002":false,
        "s003":false,
        "s004":false,
        "s005":false,
        "s006":false,
        "s007":false,
        "s008":false,
        "s009":false,
        "s010":false,
        "s011":false,
        "s012":false
    }
    $scope.checkbox_filter_post = {"park":false}

    $scope.radio_filter_price={value:''};

    $scope.selectPrice = function(price){
        $scope.selectedPriceRank = price.prId;
    }

    $scope.doFilter = function(){
        try{
            var tmpFilterOption = {};
            if ($scope.filterPost == "none") {
//                console.log('create condition: shopType : S ');
                tmpFilterOption["shopType"] = "S";

                if($scope.checkbox_filter_other.park){
//                    console.log('create condition: parking : '+$scope.checkbox_filter_other.park);
                    tmpFilterOption["parking"] = 'Y';
                }
                if($scope.checkbox_filter_other.beer){
//                    console.log('create condition: beer : '+$scope.checkbox_filter_other.beer);
                    tmpFilterOption["beer"] = 'Y';
                }
                if($scope.checkbox_filter_other.park){
//                    console.log('create condition: credit : '+$scope.checkbox_filter_other.credit);
                    tmpFilterOption["credit"] = 'Y';
                }

                if($scope.checkbox_filter_type.popular){
//                    console.log('create condition: popular : '+$scope.checkbox_filter_type.popular);
                    tmpFilterOption["popular"] = 'Y';
                }
                if($scope.checkbox_filter_type.hightrate){
//                    console.log('create condition: hightrate : '+$scope.checkbox_filter_type.hightrate);
                    tmpFilterOption["hightrate"] = 'Y';
                }
                if($scope.checkbox_filter_type.recently){
//                    console.log('create condition: recently : '+$scope.checkbox_filter_type.recently);
                    tmpFilterOption["recently"] = 'Y';
                }

                if($scope.selectedPriceRank!=''){
//                    console.log('create condition: priceRankId : '+$scope.selectedPriceRank);
                    tmpFilterOption["priceRankId"] = $scope.selectedPriceRank;
                }

                //        if(){
                //            tmpFilterOption["shopBusiness"] = '';
                //        }
            }else{
//                console.log('create condition: shopType : "P" , "B" ');
                tmpFilterOption["shopType"] = 'P,B';

                if($scope.checkbox_filter_post.park){
//                    console.log('create condition: Post parking : '+$scope.checkbox_filter_post.park);
                    tmpFilterOption["parking"] = 'Y';
                }

                if(document.getElementById("txtPostCodefilter").value!=''){
//                    console.log('create condition: postCode : '+document.getElementById("txtPostCodefilter").value);
                    tmpFilterOption["postCode"] = document.getElementById("txtPostCodefilter").value;
                }
                //Service
                if($scope.checkbox_filter_service.s001 ||
                    $scope.checkbox_filter_service.s002 ||
                    $scope.checkbox_filter_service.s003 ||
                    $scope.checkbox_filter_service.s004 ||
                    $scope.checkbox_filter_service.s005 ||
                    $scope.checkbox_filter_service.s006 ||
                    $scope.checkbox_filter_service.s007 ||
                    $scope.checkbox_filter_service.s008 ||
                    $scope.checkbox_filter_service.s009 ||
                    $scope.checkbox_filter_service.s010 ||
                    $scope.checkbox_filter_service.s011 ||
                    $scope.checkbox_filter_service.s012){
                    var serviceFilter = '';
                    var concat = '';
                    if($scope.checkbox_filter_service.s001){ serviceFilter += concat+'\'S001\'';concat=','}
                    if($scope.checkbox_filter_service.s002){ serviceFilter += concat+'\'S002\'';concat=','}
                    if($scope.checkbox_filter_service.s003){ serviceFilter += concat+'\'S003\'';concat=','}
                    if($scope.checkbox_filter_service.s004){ serviceFilter += concat+'\'S004\'';concat=','}
                    if($scope.checkbox_filter_service.s005){ serviceFilter += concat+'\'S005\'';concat=','}
                    if($scope.checkbox_filter_service.s006){ serviceFilter += concat+'\'S006\'';concat=','}
                    if($scope.checkbox_filter_service.s007){ serviceFilter += concat+'\'S007\'';concat=','}
                    if($scope.checkbox_filter_service.s008){ serviceFilter += concat+'\'S008\'';concat=','}
                    if($scope.checkbox_filter_service.s009){ serviceFilter += concat+'\'S009\'';concat=','}
                    if($scope.checkbox_filter_service.s010){ serviceFilter += concat+'\'S010\'';concat=','}
                    if($scope.checkbox_filter_service.s011){ serviceFilter += concat+'\'S011\'';concat=','}
                    if($scope.checkbox_filter_service.s012){ serviceFilter += concat+'\'S012\'';concat=','}
                    if(serviceFilter!=''){
                        tmpFilterOption["postService"] = serviceFilter;
                    }
                }
            }
            $scope.searchCriteria = tmpFilterOption;
        }catch(err){
            console.log('Error:'+err.message);
        }
        $scope.changeSearchMode('S','Filter');
    }

    $scope.selectProvice = function(province){
        if(province){
            //console.log("province:" + province.description);
			$scope.selectedProvince = angular.copy(province);
            $scope.$applyAsync(function () {
                $scope.resultList = null;
                $scope.displayPullUp = 'none';
                $scope.cursorIndex = 0;
            });
        }else{
			//console.log("province:null");
            $scope.$applyAsync(function () {
				$scope.selectedProvince = '';
                $scope.resultList = null;
                $scope.displayPullUp = 'none';
                $scope.cursorIndex = 0;
            });
        }
    }

    $scope.removeBookmark = function(shop,index){
//        console.log('removeBookmark start');
//        console.log('removeBookmark.userId:'+userSessionService.userId);
//        console.log('shop.id:'+shop.shopId);

        shopInfoService.removeBookmark(
            {
                userId:userSessionService.userId,
                locationId:shop.shopId
            }
            ,function(r){
                if(r.result.deleteResult){
                    $scope.$applyAsync(function(){
                        if(index<$scope.resultList.length){
                            $scope.resultList[index].active = false;
                            $scope.resultList.splice(index,1);
                        }
                    });
//                    console.log('delete successfully');
//                    alert(r.result.deleteResult);
                    if (r.result.deleteResult && r.result.deleteResult=='ok') {
//                        console.log('delete successfully');
                        navigator.notification.alert(
                            $scope.msg.msg_delete_ok,
                            function(){},
                            $scope.msg.msg_title_alert,
                            $scope.msg.btn_ok
                        )
                    }else{
//                        console.log('delete unsuccessfully');
                        navigator.notification.alert(
                            $scope.msg.msg_delete_fail,
                            function(){},
                            $scope.msg.msg_title_alert,
                            $scope.msg.btn_ok
                        )
                    }
                }
            });
    }

    $scope.changeSearchMode = function (mode, modeTxt) {
        $scope.curSearchMode = modeTxt;
        $scope.curMode = mode;
        //console.log("mode:" + mode);
        //console.log("modeTxt:" + modeTxt);
        var strJson = {};
        if(mode=="B"){//Bookmark
			console.log('clear');
			$scope.resultList = null;
			$scope.displayPullUp = 'none';
			$scope.cursorIndex = 0;
            if(userSessionService.userId){
                strJson["mode"] = 'B';
                strJson["userId"] = userSessionService.userId;
            }else{
                navigator.notification.confirm(
                    'Please Loggedin, Go Login?'
                    ,function(btnIndex){
                        if (btnIndex == 1) {
                            $scope.$applyAsync(function(){
                                $navigate.go('/login_form', 'slide');
                            });
                        }
                    }
                    , 'Message Box'
                    , 'Login,No');
            }
        }else if(mode=="N"){//Near By
            strJson["mode"] = 'N';
            var strPosition = {};
            geolocation.getCurrentPosition(function (position) {
//                console.log("Search By Postion: ["+position.coords.latitude+","+position.coords.longitude+"]");

                var nearByCriteria = {};
                nearByCriteria["mode"] = 'N';
                strPosition["lat"] = position.coords.latitude;
                strPosition["lng"] = position.coords.longitude;
                nearByCriteria["geolocation"] = strPosition;
                shopInfoService.searchShop(
                    nearByCriteria
                    , function (r) {
						$scope.loading = false;
                        if (r.error || !r.result) {
//                            console.log('call changeSearchMode.searchShop Error');
                            $scope.$applyAsync(function () {
                                $scope.resultList = null;
                                $scope.displayPullUp = 'none';
                                $scope.cursorIndex = 0;
                            });
                        }else if (r.result) {
//                            console.log('changeSearchMode result: ' + JSON.stringify(r.result));
                            $scope.$applyAsync(function () {
                                $scope.resultList = r.result.shopResults;
                                $scope.cursorIndex = r.result.shopResults.length;
                                if(r.result.shopResults.length>=10){
                                    $scope.displayPullUp = 'block';
                                }else{
                                    $scope.displayPullUp = 'none';
                                }
                            });
                        }
                    });



            }, function(){
            	navigator.notification.alert($scope.msg.call_geolocation_error);
                console.log("Geolocation Error!");
            },{ timeout: 10000 });
        }else if(mode=="L"){// Location
			console.log('province:'+JSON.stringify($scope.selectedProvince));
			if (!$scope.selectedProvince) return;
            strJson["mode"] = 'L';
            strJson["provinceCode"] = $scope.selectedProvince.value;
        }else if(mode=="S"){// Location
            strJson["mode"] = 'S';
            if($scope.selectedProvince!=''){
                strJson["provinceCode"] = $scope.selectedProvince.value;
            }
            if($scope.searchKeyword!=''){
                strJson["keyword"] = $scope.searchKeyword;
            }
            strJson["filterOption"] = $scope.searchCriteria;
        }
        //gen filterOption

        var filterOption = {};
        strJson["startIndex"] = 0;//$scope.cursorIndex;
        if(mode!="N" && !(mode=="B" && !userSessionService.userId)){
            $scope.searchCriteria=strJson;
            shopInfoService.searchShop(
                $scope.searchCriteria
                , function (r) {
					$scope.loading = false;
                    if (r.error || !r.result){
                        $scope.$applyAsync(function () {
                            $scope.resultList = null;
                            $scope.displayPullUp = 'none';
                            $scope.cursorIndex = 0;
                        });
                        console.log('call changeSearchMode.searchShop Error ' + JSON.stringify(r.error));
                    }
                    else if (r.result) {
                        console.log('changeSearchMode result: ' + JSON.stringify(r.result));
                        $scope.$applyAsync(function () {
                            $scope.resultList = r.result.shopResults;
                            $scope.cursorIndex = r.result.shopResults.length;
                            if(r.result.shopResults.length>=10){
                                $scope.displayPullUp = 'block';
                            }else{
                                $scope.displayPullUp = 'none';
                            }
                        });
                    }
                });
        }
    }

    $scope.loading = true;
	cordovaReady(function () {
	console.log('will get position');
//							 $scope.changeSearchMode("L", "zzz");
//						 $scope.selectedProvince = {value:"10"}
    navigator.geolocation.getCurrentPosition(
        function (position) {
            console.log("currentPositionOnload ok!");
            var strPosition = {};
            var nearByCriteria = {};
            nearByCriteria["mode"] = 'N';
            strPosition["lat"] = position.coords.latitude;
            strPosition["lng"] = position.coords.longitude;
            nearByCriteria["geolocation"] = strPosition;
			console.log('will get shop');
            shopInfoService.searchShop(
                nearByCriteria
                , function (r) {
                	console.log('getting shop');
                	$scope.loading = false;
                    if (r.error || !r.result){ console.log('call search nearby Shop Error');}
                    else if (r.result) {
//                        console.log('Nearby result: ' + JSON.stringify(r.result));
                        $scope.$applyAsync(function () {
                            $scope.resultList = r.result.shopResults;
                            if(r.result.shopResults.length>=10){
                                $scope.displayPullUp = 'block';
                            }else{
                                $scope.displayPullUp = 'none';
                            }
                        });
                    }
                });

        }, function(){
        	navigator.notification.alert($scope.msg.call_geolocation_error);
            console.log("Geolocation Error!");
        },
        { timeout: 10000 }
    )

    }, false);

//    geolocation.getCurrentPosition(function (position) {
//        console.log("currentPositionOnload ok!");
//        var strPosition = {};
//        var nearByCriteria = {};
//        nearByCriteria["mode"] = 'N';
//        strPosition["lat"] = position.coords.latitude;
//        strPosition["lng"] = position.coords.longitude;
//        nearByCriteria["geolocation"] = strPosition;
//        shopInfoService.searchShop(
//            nearByCriteria
//            , function (r) {
//                if (r.error || !r.result){ console.log('call search nearby Shop Error');}
//                else if (r.result) {
//                    console.log('Nearby result: ' + JSON.stringify(r.result));
//                    $scope.$applyAsync(function () {
//                        $scope.resultList = r.result.shopResults;
//                        if(r.result.shopResults.length>=10){
//                            $scope.displayPullUp = 'block';
//                        }else{
//                            $scope.displayPullUp = 'none';
//                        }
//                    });
//                }
//            });
//
//    }, function(){
//        console.log("Geolocation Error!");
//    },
//    { timeout: 10000 });

    //List Full Province
    provinceService.getAllProvince(function (r) {
        if (r.error || !r.result) console.log('call getAllProvince Error');
        else if (r.result) {
            $scope.provinces = r.result.allProvinces;
			console.log('province success', $scope.provinces);
			$scope.$applyAsync();

            //List Price Rank
            shopInfoService.getAllPriceRank(function (r) {
                if (r.error || !r.result) console.log('call getAllPriceRank Error');
                else if (r.result) {
//                    console.log('result: ' + JSON.stringify(r.result));
                    $scope.priceRanks = r.result.allPriceRank;
                    //List Full Popular Service
                    shopInfoService.getAllPostService(function (r) {
                        if (r.error || !r.result) console.log('call getAllPostService Error');
                        else if (r.result) {
                            $scope.branchServices = r.result.allPostServices;
                        }
                    });
                }
            });
        }
    });

    $scope.loadMore = function () {
//        console.log('load more ...........');
    	$scope.disPlayClass = 'loading';
        if (!$scope.$$phase) $scope.$applyAsync();
//        $scope.curSearchMode = modeTxt;
//        $scope.curMode = mode;
        $scope.searchCriteria["startIndex"] = $scope.cursorIndex;
        console.log(JSON.stringify($scope.searchCriteria));
//        console.log('loadMore data start at:'+$scope.cursorIndex);
        try{
        if($scope.curMode!="N"){
            shopInfoService.searchShop(
                $scope.searchCriteria
                , function (r) {
                    if (r.error || !r.result){
                    	$scope.resultList = null;
                    	$scope.displayPullUp = 'none';
                    	$scope.cursorIndex = 0;
//                        console.log('call changeSearchMode.searchShop Error');
                    }
                    else if (r.result) {
//                        console.log('changeSearchMode result: ' + JSON.stringify(r.result));
                    	$scope.cursorIndex += r.result.shopResults.length;
                    	if(r.result.shopResults.length>=10){
                    		$scope.displayPullUp = 'block';
                    	}else{
                    		$scope.displayPullUp = 'none';
                    	}
                    	for(var iRow=0;iRow<r.result.shopResults.length;iRow++){
                    		$scope.resultList.push(r.result.shopResults[iRow]);
                    	}
//                            console.log('$scope.resultList:'+$scope.resultList.length);
                    }
                    $scope.disPlayClass = 'flip';
                    if (!$scope.$$phase) $scope.$applyAsync();
                });
        }
        }catch(err){console.log('error:'+err);}
    }

});