'use strict';
postLensApp.controller('userCommentCtrl', function($scope, userProfile_DataModel, userProfileService, captureService,$window,$ionicScrollDelegate) {
    $scope.xxx = null;
    $scope.bodyHeight = ($window.innerHeight - 120)+'px';
    
   	function showUserComment(){
		userProfileService.getUserComment({userId: $scope.userProfile.id}
		, function(r){
			if(r.error || !r.result) console.log('call getUserComment Error');
			else if(r.result){
				$scope.$applyAsync(function(){
					$scope.userComments = r.result.comments;
				});
				
			}
		});
	}
	
   	$scope.dropComment = function(commentIndex){
    	navigator.notification.confirm('Confirm Delete Comment?'
			, function(index) {
				if(index == 1){
					var delCommentId = $scope.userComments[commentIndex].commentId;
//					console.log("do drop UserComment =" + delCommentId);
					
					userProfileService.dropUserComment({commentId: delCommentId}
						, function(r){
							if(r.error || !r.result) console.log('call dropComment Error');
							else if(r.result && r.result.saveResult == "ok"){
//								console.log("dropComment complete.");
								showUserComment();
							}else{
								alert('saveComment error!');
							}
						});
					
				}
			}
			, 'Message'
			, 'Yes'+','+'No');
    }
   	
	$scope.initEditComment = function(usrComment){
//		console.log("do initEditComment...");
		$scope.editComment = angular.copy(usrComment);
		$scope.editComment.addImageList = [];
		$scope.editComment.deleteCommentImageIdList = [];
		
		for(var i = 0; i < $scope.userComments.length; ++i){
			$scope.userComments[i].active = false;
		}
		
		//open
		usrComment.active = true;//!usrComment.active;
		$ionicScrollDelegate.scrollTop();
	}

	$scope.cancelEdit = function() {
		$scope.editComment = null;
		for(var i = 0; i < $scope.userComments.length; ++i){
			$scope.userComments[i].active = false;
		}
		$ionicScrollDelegate.scrollTop();
	}
	
	$scope.attachImage = function(){
		captureService.cameraCapture(onSuccess 
			,onFail
			,{ quality: 50
				,encodingType: Camera.EncodingType.JPEG
		  		,destinationType : Camera.DestinationType.DATA_URL
                ,targetWidth: 150
                ,targetHeight: 100});
	}
	
	function onSuccess(imageData) {
//        console.log('onSuccess');
        
        /*console.log('onSuccess add image');
//      $scope.xxx = $scope.userComments[$scope.editIndex];
      $scope.xxx = $scope.editComment.imageList;
      $scope.$applyAsync(function(){
          $scope.editComment.imageList = [];
      });
      
      var imgObj = {
      		imageUrl : "data:image/jpeg;charset=utf-8;base64,"+imageData
      };
      
      $scope.xxx.push(imgObj);
      console.log('xxx.length : '+$scope.xxx.length);

      $scope.$applyAsync(function(){
//          $scope.userComments[$scope.editIndex].imageList = [];
          $scope.editComment.imageList = $scope.xxx;
      });
//      $scope.$applyAsync();
*/      
      $scope.$applyAsync(function(){
    	  $scope.editComment.addImageList.push(imageData);
      });
      
	}

	function onFail(message) {
	    navigator.notification.alert('Failed because: ' + message);
	}
	
	$scope.confirmDeleteImage = function (editImageListIndex){
		var imgObj = $scope.editComment.imageList[editImageListIndex];
//		console.log("delete image: "+JSON.stringify(imgObj));
		
		navigator.notification.confirm('Confirm Delete Image?'
			, function(index) {
				if(index == 1){
					$scope.$applyAsync(function(){
						if(imgObj.commentImageId){
							$scope.editComment.deleteCommentImageIdList.push(imgObj.commentImageId);
						}
						$scope.editComment.imageList.splice(editImageListIndex,1);
					});
				}
			}
			, 'Message'
			, 'Yes'+','+'No');
	}
	
	$scope.confirmDeleteAddImage = function (addImageIndex){
//		console.log("delete addImage index: "+addImageIndex);
		
		navigator.notification.confirm('Confirm Delete Image?'
			, function(index) {
				if(index == 1){
					$scope.$applyAsync(function(){
						$scope.editComment.addImageList.splice(addImageIndex,1);
					});
					
				}
			}
			, 'Message'
			, 'Yes'+','+'No');
	}
	
	$scope.saveUserComment = function(){
//		console.log("do save UserComment =" + JSON.stringify($scope.editComment));
		
		userProfileService.saveUserComment($scope.editComment
			, function(r){
				if(r.error || !r.result) console.log('call saveUserComment Error');
				else if(r.result && r.result.saveResult == "ok"){
//					console.log("saveUserComment complete.");
					showUserComment();
				}else{
					alert('saveComment error!');
				}
			});
		
	}
	
	$scope.userProfile = userProfile_DataModel.userProfile;
	
	showUserComment();
});