'use strict';

postLensApp.factory('facebook', function($rootScope, cordovaReady) {
  // Service logic
  // ...
  var permissions = "public_profile,email,user_birthday,user_location,user_photos".split(',');
	function fbinit() {
	    console.log('fbinit');
		try {
			FB.init({ appId: "144327195708469", nativeInterface: CDV.FB, useCachedDialogs: false });
		} catch (e) {
			console.log("fbinit error: "+e);
		}
	}
	
	function login(successCB, errorCB) {
		checkLoginStatus(
			function(resp1) {
				successCB(resp1);
			},
			function() {
				console.log('login NEW');
				facebookConnectPlugin.login(permissions,
				 function(resp1) {
					console.log('R1 ' + JSON.stringify(resp1));
					console.log('logged in');
					if(successCB) {
						successCB(resp1);
					}
				 }, function(resp2) {
					console.log('R2 ' + JSON.stringify(resp2));
					console.log('not logged in');
					if(errorCB) {
						errorCB(resp2);
					}
				 });
			})
	}

	function logout() {
		console.log('fb logout NEW');
		facebookConnectPlugin.logout(
		function(response) {
			console.log('logout response: ' + JSON.stringify(response));
	        console.log('logged out');
	        console.log("logout from facebook already");
	    },function(response){
			console.log('failed to logout: ' + JSON.stringify(response));
		});
	}

	function checkLoginStatus(onLogin, onNotLogin) {
		console.log('checkLoginStatus');
		facebookConnectPlugin.getLoginStatus(
		function(response) {
	        if (response.status == 'connected') {
	        	console.log('logged in');
	        	if(onLogin) {
	        		onLogin(response);
	        	}
	        } else {
	        	console.log('not logged in');
	        	if(onNotLogin) {
	        		onNotLogin(response);
	        	}
	        }
		}, function(response){
			console.log('check login failed');
		})
	}
	
	function me(cb) {
		function meme() {
			console.log('call api');
			facebookConnectPlugin.api('/me?fields=id,first_name,last_name,email,birthday,location,picture.type(large)', 
				null, function(response) {
				console.log('me :' + JSON.stringify(response));
				if(cb){
	  			  cb(response);
				}
	  		}, function (failed) {
	  			console.log('fail', failed)
	  		});
		}
	  	checkLoginStatus(function() {
			meme();
	  	},function() {
	  		login(function() { meme(); }
    		, function() {
    			alert("cannot login before me query.");
    		});
	  	});
	}
	
	function profilePic(cb) {
		function meme() {
			facebookConnectPlugin.api('/me?fields=picture.type(large)', permissions, function(response) {
				console.log('me :' + JSON.stringify(response));
				console.log('picture url :' + JSON.stringify(response.picture.data.url));
				console.log('is_silhouette :' + JSON.stringify(response.picture.data.is_silhouette));
				if(cb){
					cb(response);
				}
			});
		}
	  	checkLoginStatus(function() {
			meme();
	  	},function() {
	  		login(function() { meme(); }
    		, function() {
    			alert("cannot login before me query.");
    		});
	  	});
	}
	
	function share(shareName, shareLink, sharePicture, shareCap, shareDesc) {
		function meme() {
    		var params = {
    				method : 'share',//'feed',
    				name : shareName,
    				//link
    				href : shareLink,
    				caption : shareCap,
    				description : shareDesc
    			};
    		if(sharePicture != null && sharePicture != ''){
    			if(sharePicture.indexOf('http://') < 0){
    				sharePicture = 'https://mobile.thailandpost.com/TP/media/resources/images/' + sharePicture;
    			}
    			
    			params.picture = sharePicture;
    		}
    		
            console.log('params: ' + JSON.stringify(params));
    		facebookConnectPlugin.showDialog(params, function(obj) {
    			console.log(obj);
    		}, function(failedobj) {
				console.log(failedobj);
			});
    	}
    	checkLoginStatus(function() {
			meme();
		},function() {
    		login(function() { meme(); }
    		, function() {
    			alert("cannot login before share.");
    		});
    	});
    }

  // Public API here
  return {
	init: cordovaReady(function(){
			console.log("fbinit()..");
			//fbinit();
		}
	)
	
	,login: login
	
	,logout: logout
	  
    ,share: share
	,me: me
	  
	,profilePic: profilePic

  };
});
