'use strict';
postLensApp.factory('pushMessageService', function ($rootScope, cordovaReady) {
    //require ionic to work
    var projectID = "845509757442";
    var device = {platform : ionic.Platform.platform()};

    var messageService = {
        initRegisterPushMessage : function(cb) { 
            cordovaReady(function(){
                console.log('cordovaReady initRegisterPushMessage');

                var options ={};
                if(device.platform==='android'||device.platform==='Android'){
                options ={"android":{"senderID":projectID}};

                } else if(device.platform==='ios'){
                options ={"ios":{}};
                }
                var push = PushNotification.init({ "android": {"senderID": projectID},
                     "ios": {}} );
                push.on('registration', function(data) {
                    // alert(data.registrationId);
                    window.localStorage.setItem("token_regid", data.registrationId);

                    console.log('registration event-->',data.registrationId,data);
                });
                if (cb) cb(push);
            })()
        }
        ,setRegIdToJSON : function(jsonObj) {
            try{
                if (device && device.platform) {
                    console.log("platform: " + device.platform);
                    if(device.platform==='android'||device.platform==='Android'){
                        jsonObj.platform = 'ANDROID';
                        //GCM
                        var gcm_regid = window.localStorage.getItem("token_regid");
                        console.log("gcm_regid: " + gcm_regid);
                        if (gcm_regid) {
                            jsonObj.regId = gcm_regid;
                        }
                    } else if (device.platform.indexOf('iPhone') >= 0
                        || device.platform.indexOf('iPad') >= 0
                        || device.platform.indexOf('iOS') >= 0
                        || device.platform==='ios') {
                        jsonObj.platform = 'IOS';
                        // ios push
                        var ios_regid = window.localStorage.getItem("token_regid");
                        console.log("ios_regid: " + ios_regid);
                        if (ios_regid) {
                            jsonObj.regId = ios_regid;
                        }
                    }
                }


            }catch(err){
                console.log('err:'+err);
            }
            return jsonObj;
        }
    }
    return messageService;

});