postLensApp.factory('rpcService', function ($window, $timeout, $interval, $http, apiBaseUrl, appInfo) {
//	//init rpc
//	$window.connect();
	//var api = 'http://192.168.2.1:6442/api';
	var api = apiBaseUrl;
	
	function callRPC(call){
		var doCall = function(){
			if($window.remote){
				console.info('calling');
				call();
			} else{
				console.info('delayed call 2s');
                $timeout(doCall, 2000, false);
        	}
		}
		
		return doCall;
	}

	function onSuccess(cb) {
		return function(res) {
			console.log(res);
			if (res && res.data && res.data.error && (res.data.flag == 'v_error')) {
				alert(res.data.error);
			}
			cb(res.data);
		}
	}

	function onError(cb) {
		return function(err) {
			console.log(err);
			if (err && err.flag == 'v_error') {
				alert(err.error);
			}
			cb(err);
		}
	}
	
	return {
        vote : function(arg, cb){
			$http.post(api+'/vote', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
        //Not Use
        ,wsGetCusByEmail : function(arg,cb){
            callRPC(function(){
                $window.remote.GetCusByEmail(arg,cb);
            })();
        }
        //Not Use
        ,wsInsertNewCus : function(arg,cb){
            callRPC(function(){
                $window.remote.InsertNewCus(arg,cb);
            })();
        }
        ,wsGetTrackandTrace : function(arg,cb){
			$http.post(api+'/GetTrackandTrace', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
        ,getShopLandmarkByShop : function(arg,cb){
			$http.post(api+'/getShopLandmarkByShop', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
        ,getUserProfile : function(arg,cb){
			$http.post(api+'/getUserProfile', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,getFollowList : function(arg,cb){
			$http.post(api+'/getFollowList', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,getFollowingList : function(arg,cb){
			$http.post(api+'/getFollowingList', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,getShopBranchInfo : function(arg,cb){
			$http.post(api+'/getShopBranchInfo', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,getComment : function(arg,cb){
			$http.post(api+'/getComment', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,getImage : function(arg,cb){
			$http.post(api+'/getImage', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
        ,getPromotion : function(arg,cb){
			$http.post(api+'/getPromotion', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
		,getPromotionLimit : function(arg,cb){
			$http.post(api+'/getPromotionLimit', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
        ,getAllPromotion : function(arg,cb){
			$http.post(api+'/getAllPromotion', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
        ,getAllCoupon : function(arg,cb){
			$http.post(api+'/getAllCoupon', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
		,getCoupon : function(arg,cb){
			$http.post(api+'/getCoupon', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
        ,getDropdownShop : function(arg,cb){
			$http.post(api+'/getDropdownShop', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
        ,getDropdownShopType : function(cb){
			$http.post(api+'/getDropdownShopType', {args:[]})
			.then(onSuccess(cb), onError(cb))
        }
        ,updateShopLocationAndImage : function(arg,cb){
			$http.post(api+'/updateShopLocationAndImage', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
        ,saveShopLocationAndImage : function(arg,cb){
			$http.post(api+'/saveShopLocationAndImage', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
		,searchShop : function(arg,cb){
			$http.post(api+'/searchShop', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,getAllPostService : function(cb){
			$http.post(api+'/getAllPostService', {args:[]})
			.then(onSuccess(cb), onError(cb))

		}
		,getAllProvince : function(cb){
			$http.post(api+'/getAllProvince', {args:[]})
			.then(onSuccess(cb), onError(cb))

		}
		,saveComment : function(arg,cb){
			$http.post(api+'/saveComment', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,dropComment : function(arg,cb){
			$http.post(api+'/dropComment', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,addFollowingUser : function(arg,cb){
			$http.post(api+'/addFollowingUser', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,confirmFollowerUser : function(arg,cb){
			$http.post(api+'/confirmFollowerUser', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
		,leaveFollowingUser : function(arg,cb){
			$http.post(api+'/leaveFollowingUser', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,blockFollowerUser : function(arg,cb){
			$http.post(api+'/blockFollowerUser', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,deleteFollowUser : function(arg,cb){
			$http.post(api+'/deleteFollowUser', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
		,deleteFollowingUser : function(arg,cb){
			$http.post(api+'/deleteFollowingUser', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
		,likeComment : function(arg,cb){
			$http.post(api+'/likeComment', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
        ,updateLikeCommentConfig : function(arg,cb){
			$http.post(api+'/updateLikeCommentConfig', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
        ,updateFollowConfig : function(arg,cb){
			$http.post(api+'/updateFollowConfig', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
		,saveImage : function(arg,cb){
			$http.post(api+'/saveImage', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,deleteUserImage : function(arg,cb){
			$http.post(api+'/deleteUserImage', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,addBookmark : function(arg,cb){
			$http.post(api+'/addBookmark', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,removeBookmark : function(arg,cb){
			$http.post(api+'/removeBookmark', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,saveProfile : function(arg,cb){
			$http.post(api+'/saveProfile', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,login : function(arg,cb){
			$http.post(api+'/login', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,redeemCoupon : function(arg,cb){
			var r = {error: null, result:{}};
			r.result.redeemCouponInfo = {redeemCode : 'code11'};
			cb(r);
		}
		,changePassword : function(arg,cb){
			var r = {error: null, result:{}};
			r.result.saveResult = "ok";
			cb(r);
		}
		,resetPassword : function(arg,cb){
			var r = {error: null, result:{}};
			r.result.saveResult = "ok";
			cb(r);
		}
		,register : function(arg,cb){
			$http.post(api+'/register', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,saveShopInfo : function(arg,cb){
			var r = {error: null, result:{}};
			r.result.saveResult = "ok";
			cb(r);
		}
		,getAllPriceRank : function(cb){
			$http.post(api+'/getAllPriceRank', {args:[]})
			.then(onSuccess(cb), onError(cb))
        }
		,getNewValidateCode : function(arg,cb){
			$http.post(api+'/getNewValidateCode', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
		,registerConfirm : function(arg,cb){
			$http.post(api+'/registerConfirm', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
		,registerCancel : function(arg,cb){
			$http.post(api+'/registerCancel', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
        ,getPostServiceInfo : function(arg,cb){
			$http.post(api+'/getPostServiceInfo', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
        ,changeUserPassword : function(arg,cb){
			$http.post(api+'/changeUserPassword', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
        }
		,searchLandmark : function(arg,cb){
			$http.post(api+'/searchLandmark', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,getShopInfoByPostcode : function(arg,cb){
			$http.post(api+'/getShopInfoByPostcode', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
		,getAllShopType : function(arg,cb){
			$http.post(api+'/getAllShopType', {args:[arg]})
			.then(onSuccess(cb), onError(cb))
		}
	};
});