postLensApp.factory('rpcService', function ($window, $timeout, $interval) {
//	//init rpc
//	$window.connect();
	
	function callRPC(call){
		var doCall = function(){
			if($window.remote){
				console.info('calling');
				call();
			} else{
				console.info('delayed call 2s');
                $timeout(doCall, 2000, false);
        	}
		}
		
		return doCall;
	}
	
	return {
        vote : function(arg, cb){
                $window.remote.vote(arg, cb);
        }
        //Not Use
        ,wsGetCusByEmail : function(arg,cb){
            callRPC(function(){
                $window.remote.GetCusByEmail(arg,cb);
            })();
        }
        //Not Use
        ,wsInsertNewCus : function(arg,cb){
            callRPC(function(){
                $window.remote.InsertNewCus(arg,cb);
            })();
        }
        ,wsGetTrackandTrace : function(arg,cb){
            callRPC(function(){
                $window.remote.GetTrackandTrace(arg,cb);
            })();
        }
        ,getShopLandmarkByShop : function(arg,cb){
                $window.remote.getShopLandmarkByShop(arg,cb);
        }
        ,getUserProfile : function(arg,cb){
			callRPC(function(){
				$window.remote.getUserProfile(arg,cb);
			})();
		}
		,getFollowList : function(arg,cb){

			$window.remote.getFollowList(arg,cb);
		}
		,getFollowingList : function(arg,cb){
			$window.remote.getFollowingList(arg,cb);
		}
		,getShopBranchInfo : function(arg,cb){
			callRPC(function(){
				$window.remote.getShopBranchInfo(arg, cb);
			})();

		}
		,getComment : function(arg,cb){

			callRPC(function(){
				$window.remote.getComment(arg,cb);
			})();
		}
		,getImage : function(arg,cb){
			callRPC(function(){
				$window.remote.getImage(arg, cb);
			})();
		}
        ,getPromotion : function(arg,cb){
            callRPC(function(){
                $window.remote.getPromotion(arg, cb);
            })();
        }
		,getPromotionLimit : function(arg,cb){
			callRPC(function(){
				$window.remote.getPromotionLimit(arg, cb);
			})();
		}
        ,getAllPromotion : function(arg,cb){
            callRPC(function(){
                $window.remote.getAllPromotion(arg, cb);
            })();
        }
        ,getAllCoupon : function(arg,cb){
            callRPC(function(){
                $window.remote.getAllCoupon(arg, cb);
            })();
        }
		,getCoupon : function(arg,cb){
			callRPC(function(){
				$window.remote.getCoupon(arg, cb);
			})();
		}
        ,getDropdownShop : function(arg,cb){
            callRPC(function(){
                $window.remote.getDropdownShop(arg, cb);
            })();
        }
        ,getDropdownShopType : function(cb){
            callRPC(function(){
                $window.remote.getDropdownShopType(cb);
            })();
        }
        ,updateShopLocationAndImage : function(arg,cb){
            callRPC(function(){
                $window.remote.updateShopLocationAndImage(arg, cb);
            })();
        }
        ,saveShopLocationAndImage : function(arg,cb){
            callRPC(function(){
                $window.remote.saveShopLocationAndImage(arg, cb);
            })();
        }
		,searchShop : function(arg,cb){
			callRPC(function(){
				$window.remote.searchShop(arg, cb);
			})();
		}
		,getAllPostService : function(cb){
			
			callRPC(function(){
				$window.remote.getAllPostService(cb);
			})();

		}
		,getAllProvince : function(cb){
			
			callRPC(function(){
				$window.remote.getAllProvince(cb);
			})();

		}
		,saveComment : function(arg,cb){
			callRPC(function(){
				$window.remote.saveComment(arg,cb);
			})();
		}
		,dropComment : function(arg,cb){
			callRPC(function(){
				$window.remote.dropComment(arg,cb);
			})();
		}
		,addFollowingUser : function(arg,cb){
            $window.remote.addFollowingUser(arg,cb);
		}
		,confirmFollowerUser : function(arg,cb){
            $window.remote.confirmFollowerUser(arg,cb);
        }
		,leaveFollowingUser : function(arg,cb){
            $window.remote.leaveFollowingUser(arg,cb);
		}
		,blockFollowerUser : function(arg,cb){
            $window.remote.blockFollowerUser(arg,cb);
		}
		,deleteFollowUser : function(arg,cb){
            $window.remote.deleteFollowUser(arg,cb);
        }
		,deleteFollowingUser : function(arg,cb){
            $window.remote.deleteFollowingUser(arg,cb);
        }
		,likeComment : function(arg,cb){
            $window.remote.likeComment(arg,cb);
		}
        ,updateLikeCommentConfig : function(arg,cb){
            $window.remote.updateLikeCommentConfig(arg,cb);
        }
        ,updateFollowConfig : function(arg,cb){
            $window.remote.updateFollowConfig(arg,cb);
        }
		,saveImage : function(arg,cb){
			callRPC(function(){
				$window.remote.saveImage(arg,cb);
			})();
		}
		,deleteUserImage : function(arg,cb){
			callRPC(function(){
				$window.remote.deleteUserImage(arg,cb);
			})();
		}
		,addBookmark : function(arg,cb){
            $window.remote.addBookmark(arg,cb);
		}
		,removeBookmark : function(arg,cb){
            $window.remote.removeBookmark(arg,cb);
		}
		,saveProfile : function(arg,cb){
			callRPC(function(){
				$window.remote.saveProfile(arg,cb);
			})();
		}
		,login : function(arg,cb){
			callRPC(function(){
				$window.remote.login(arg,cb);
			})();
		}
		,redeemCoupon : function(arg,cb){
			var r = {error: null, result:{}};
			r.result.redeemCouponInfo = {redeemCode : 'code11'};
			cb(r);
		}
		,changePassword : function(arg,cb){
			var r = {error: null, result:{}};
			r.result.saveResult = "ok";
			cb(r);
		}
		,resetPassword : function(arg,cb){
			var r = {error: null, result:{}};
			r.result.saveResult = "ok";
			cb(r);
		}
		,register : function(arg,cb){
			callRPC(function(){
                $window.remote.register(arg,cb);
            })();
		}
		,saveShopInfo : function(arg,cb){
			var r = {error: null, result:{}};
			r.result.saveResult = "ok";
			cb(r);
		}
		,getAllPriceRank : function(cb){
            callRPC(function(){
                $window.remote.getAllPriceRank(cb);
            })();
        }
		,getNewValidateCode : function(arg,cb){
            callRPC(function(){
                $window.remote.getNewValidateCode(arg,cb);
            })();
        }
		,registerConfirm : function(arg,cb){
            callRPC(function(){
                $window.remote.registerConfirm(arg,cb);
            })();
        }
		,registerCancel : function(arg,cb){
            callRPC(function(){
                $window.remote.registerCancel(arg,cb);
            })();
        }
        ,getPostServiceInfo : function(arg,cb){
            $window.remote.getPostServiceInfo(arg,cb);
        }
        ,changeUserPassword : function(arg,cb){
        	$window.remote.changeUserPassword(arg,cb);
        }
		,searchLandmark : function(arg,cb){
			$window.remote.searchLandmark(arg,cb);
		}
		,getShopInfoByPostcode : function(arg,cb){
			$window.remote.getShopInfoByPostcode(arg,cb);
		}
	};
});