'use strict';

postLensApp.factory('shopInfoService', function (rpcService, userSessionService, shopInfo_DataModel) {
	var allPostServiceCache = null;
	var allPriceRankCache = null;
    return {
    	getShopBranchInfo:function(arg,cb){
        	rpcService.getShopBranchInfo(arg,cb);
        },
        getShopLandmarkByShop:function(arg, cb){
            rpcService.getShopLandmarkByShop(arg, cb);
        },
        vote:function(arg, cb){
            console.log('shopInfoService vote Start --userId:'+userSessionService.userId);
			if (userSessionService.isLogin()) {
				arg.userId = userSessionService.userId;
				rpcService.vote(arg, cb);
			} else {
				cb({error:{message:"Not logged in"}, requireLogin:true});
			}
        },
        getDropdownShop:function(arg, cb){
            rpcService.getDropdownShop(arg, cb);
        },
        getDropdownShopType:function(cb){
            rpcService.getDropdownShopType(cb);
        },
        searchShop:function(arg, cb){
        	rpcService.searchShop(arg, cb);
        },
        searchAllPromotion:function(arg, cb){
            rpcService.getAllPromotion(arg, cb);
        },
        searchAllCoupon:function(arg, cb){
            rpcService.getAllCoupon(arg, cb);
        },
        searchPromotion:function(arg, cb){
            rpcService.getPromotion(arg, cb);
        },
        searchPromotionLimit:function(arg, cb){
            rpcService.getPromotionLimit(arg, cb);
        },
        searchCoupon:function(arg, cb){
        	rpcService.getCoupon(arg, cb); 
        },
        searchComment:function(arg, cb){
        	rpcService.getComment(arg, cb); 
        },
        searchImageUpload:function(arg, cb){
        	rpcService.getImage(arg, cb); 
        },
        getAllPostService:function(cb){
			if (!allPostServiceCache) {
				rpcService.getAllPostService(function(r){
					if (!r.error) allPostServiceCache = r;
					cb(r);
				});
			} else cb(allPostServiceCache);
        },
        getAllBookmarkShop:function(arg, cb){
            rpcService.searchShop(arg, cb);
        },
        getAllRecommendedShop:function(arg, cb){
            rpcService.searchShop(arg, cb);
        },
        saveShopComment:function(arg, cb){
            rpcService.saveComment(arg, cb);
        },
        saveShopImage:function(arg, cb){
            rpcService.saveImage(arg, cb);
        },
        addBookmark:function(arg, cb){
            rpcService.addBookmark(arg, cb);
        },
        removeBookmark:function(arg, cb){
            rpcService.removeBookmark(arg, cb);
        },
        getAllPriceRank:function(cb){
			if (!allPriceRankCache) {
				rpcService.getAllPriceRank(function(r){
					if (!r.error) allPriceRankCache = r;
					cb(r);
				});
			} else cb(allPriceRankCache);
        },
        updateShopLocationAndImage:function(arg, cb){
            rpcService.updateShopLocationAndImage(arg, cb);
        },
        saveShopLocationAndImage:function(arg, cb){
            rpcService.saveShopLocationAndImage(arg, cb);
        },
        getPostServiceInfo:function(arg, cb){
            rpcService.getPostServiceInfo(arg, cb);
        },
		searchLandmark:function(arg,cb){
			rpcService.searchLandmark(arg, cb);
		},
		getShopInfoByPostcode:function(arg,cb){
			rpcService.getShopInfoByPostcode(arg, cb);
		}
    }
});