'use strict';
postLensApp.factory('userSessionService', function (cordovaReady, rpcService) {
	var serviceObj = {
		username : null
        ,userId : null
        ,userRef : null
        // username : "test"
        // ,userId : 1
        // ,userRef : 1
		,isUserFacebook : false
        ,notifyLikeComment : 'N'
        ,notifyFollow : 'N'
        ,isStepRegister : true
		,regisInfo : {
            firstName : ''
            ,lastName : ''
            ,email : ''
            ,password : ''
            ,language : ''
            ,birth_date : ''
            ,platform : ''
            ,regId : ''
        }
		,isPostLensAdmin : 'N'

        ,initUserSession : cordovaReady(function(){
				console.log("initUserSession...");
                console.log("user :"+window.localStorage.getItem("user"));
                console.log("userRef :"+window.localStorage.getItem("userRef"));
				console.log("isUserFacebook :"+window.localStorage.getItem("isUserFacebook"));
                console.log("notifyLikeComment :"+window.localStorage.getItem("notifyLikeComment"));
                console.log("notifyFollow :"+window.localStorage.getItem("notifyFollow"));
			
				if(window.localStorage.getItem("user")){
					serviceObj.username = window.localStorage.getItem("user");
				}
                if(window.localStorage.getItem("userRef")){
                    serviceObj.userRef = window.localStorage.getItem("userRef");
                }
				if(window.localStorage.getItem("userId")){
					serviceObj.userId = parseInt(window.localStorage.getItem("userId"));
				}
				if(window.localStorage.getItem("isUserFacebook")){
					serviceObj.isUserFacebook = JSON.parse(window.localStorage.getItem("isUserFacebook"));
				}
                if(window.localStorage.getItem("notifyLikeComment")){
                    serviceObj.notifyLikeComment = window.localStorage.getItem("notifyLikeComment");
                }
                if(window.localStorage.getItem("notifyFollow")){
                    serviceObj.notifyFollow = window.localStorage.getItem("notifyFollow");
                }
                if(window.localStorage.getItem("isPostLensAdmin")){
                    serviceObj.isPostLensAdmin = window.localStorage.getItem("isPostLensAdmin");
                }
                
			}
		)
        ,setToggleOnComment : function(){
            this.notifyLikeComment = 'Y';
            window.localStorage.setItem("notifyLikeComment", 'Y');
        }
        ,setToggleOffComment : function(){
            this.notifyLikeComment = 'N';
            window.localStorage.setItem("notifyLikeComment", 'N');
        }
        ,setToggleComment : function(flag){
            if (flag=='Y' || flag=='N') {
                this.notifyLikeComment = flag;
                window.localStorage.setItem("notifyLikeComment", flag);
            }
        }
        ,setToggleOnFollow : function(){
            this.notifyFollow = 'Y';
            window.localStorage.setItem("notifyFollow", 'Y');
        }
        ,setToggleOffFollow : function(){
            this.notifyFollow = 'N';
            window.localStorage.setItem("notifyFollow", 'N');
        }
        ,setToggleFollow : function(flag){
            if (flag=='Y' || flag=='N') {
                this.notifyFollow = flag;
                window.localStorage.setItem("notifyFollow", flag);
            }
        }
		,setUserSession : function(username, userId, isUserFacebook, notifyCom, notifyFw, userRef, isPostLensAdmin){
			this.username = username;
			this.userId = userId;
            this.userRef = userRef;
			this.isUserFacebook = isUserFacebook;
            this.notifyLikeComment = notifyCom;
            this.notifyFollow = notifyFw;
            this.isPostLensAdmin = isPostLensAdmin;
			window.localStorage.setItem("user", username);
			window.localStorage.setItem("userId", userId);
            window.localStorage.setItem("userRef", userRef);
			window.localStorage.setItem("isUserFacebook", isUserFacebook);
            window.localStorage.setItem("notifyLikeComment", notifyCom);
            window.localStorage.setItem("notifyFollow", notifyFw);
            window.localStorage.setItem("isPostLensAdmin", isPostLensAdmin);
            
		}
		,clearUserSession : function(){
			this.username = null;
			this.userId = null;
            this.userRef = null;
			this.isUserFacebook = false;
			this.isPostLensAdmin = 'N';
			window.localStorage.removeItem("user");
			window.localStorage.removeItem("userId");
            window.localStorage.removeItem("userRef");
			window.localStorage.removeItem("isUserFacebook");
            window.localStorage.removeItem("notifyLikeComment");
            window.localStorage.removeItem("notifyFollow");
            window.localStorage.removeItem("regisInfo");
            window.localStorage.removeItem("isPostLensAdmin");
		}
		,isLogin : function(){
			console.log("username: "+this.username);
			return this.username && this.username != '';
		}
		
		,initRegisInfo : cordovaReady(function(){
                try{
                    console.log("initRegisInfo...");
                    var regisInfoStr = window.localStorage.getItem("regisInfo");

                    if(regisInfoStr){
                        console.log("load local data regisInfo :"+regisInfoStr);
                        serviceObj.regisInfo = JSON.parse(regisInfoStr);
                        serviceObj.isStepRegister = false;
                    }else{
                        console.log("no local data regisInfo");
                        serviceObj.regisInfo = null;
                        serviceObj.isStepRegister = true;
                    }
                }catch(err){console.log('initRegisInfo Error:'+err);}
			}
		)
		,setRegisInfo : function(regisInfo){
			this.regisInfo = regisInfo;
            console.log('setRegisInfo:'+JSON.stringify(regisInfo));
			window.localStorage.setItem("regisInfo", JSON.stringify(regisInfo));
		}
		,clearRegisInfo : function(){
			this.regisInfo = null;
			window.localStorage.removeItem("regisInfo");
            serviceObj.isStepRegister = true;
		}
		
		//rpc part
		,login : function(arg,cb){
			rpcService.login(arg,cb);
		}
		,register : function(arg,cb){
			rpcService.register(arg,cb);
		}
		,getNewValidateCode : function(arg,cb){
			rpcService.getNewValidateCode(arg,cb);
		}
		,registerConfirm : function(arg,cb){
			rpcService.registerConfirm(arg,cb);
		}
		,registerCancel : function(arg,cb){
			rpcService.registerCancel(arg,cb);
		}
        ,updateLikeCommentConfig : function(arg,cb){
            rpcService.updateLikeCommentConfig(arg,cb);
        }
        ,updateFollowConfig : function(arg,cb){
            rpcService.updateFollowConfig(arg,cb);
        }
	};

	return serviceObj;
});